#ifndef DOM_BINDINGNAMES_H_
#define DOM_BINDINGNAMES_H_

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioData = 335,
  AudioDecoder = 345,
  AudioDestinationNode = 358,
  AudioEncoder = 379,
  AudioListener = 392,
  AudioNode = 406,
  AudioParam = 416,
  AudioParamMap = 427,
  AudioProcessingEvent = 441,
  AudioScheduledSourceNode = 462,
  AudioTrack = 487,
  AudioTrackList = 498,
  AudioWorklet = 513,
  AudioWorkletGlobalScope = 526,
  AudioWorkletNode = 550,
  AudioWorkletProcessor = 567,
  AuthenticatorAssertionResponse = 589,
  AuthenticatorAttestationResponse = 620,
  AuthenticatorResponse = 653,
  BarProp = 675,
  BaseAudioContext = 683,
  BatteryManager = 700,
  BeforeUnloadEvent = 715,
  BiquadFilterNode = 733,
  Blob = 750,
  BlobEvent = 755,
  BroadcastChannel = 765,
  BrowsingContext = 782,
  BrowsingContextGroup = 798,
  ByteLengthQueuingStrategy = 819,
  CDATASection = 845,
  CSS = 858,
  CSS2Properties = 862,
  CSSAnimation = 877,
  CSSConditionRule = 890,
  CSSContainerRule = 907,
  CSSCounterStyleRule = 924,
  CSSCustomPropertyRegisteredEvent = 944,
  CSSFontFaceRule = 977,
  CSSFontFeatureValuesRule = 993,
  CSSFontPaletteValuesRule = 1018,
  CSSGroupingRule = 1043,
  CSSImportRule = 1059,
  CSSKeyframeRule = 1073,
  CSSKeyframesRule = 1089,
  CSSLayerBlockRule = 1106,
  CSSLayerStatementRule = 1124,
  CSSMarginRule = 1146,
  CSSMediaRule = 1160,
  CSSMozDocumentRule = 1173,
  CSSNamespaceRule = 1192,
  CSSPageRule = 1209,
  CSSPropertyRule = 1221,
  CSSPseudoElement = 1237,
  CSSRule = 1254,
  CSSRuleList = 1262,
  CSSScopeRule = 1274,
  CSSStartingStyleRule = 1287,
  CSSStyleDeclaration = 1308,
  CSSStyleRule = 1328,
  CSSStyleSheet = 1341,
  CSSSupportsRule = 1355,
  CSSTransition = 1371,
  Cache = 1385,
  CacheStorage = 1391,
  CallbackDebuggerNotification = 1404,
  CanonicalBrowsingContext = 1433,
  CanvasCaptureMediaStream = 1458,
  CanvasGradient = 1483,
  CanvasPattern = 1498,
  CanvasRenderingContext2D = 1512,
  CaretPosition = 1537,
  CaretStateChangedEvent = 1551,
  ChannelMergerNode = 1574,
  ChannelSplitterNode = 1592,
  ChannelWrapper = 1612,
  CharacterData = 1627,
  CheckerboardReportService = 1641,
  ChildProcessMessageManager = 1667,
  ChildSHistory = 1694,
  ChromeMessageBroadcaster = 1708,
  ChromeMessageSender = 1733,
  ChromeNodeList = 1753,
  ChromeUtils = 1768,
  ChromeWorker = 1780,
  Client = 1793,
  Clients = 1800,
  Clipboard = 1808,
  ClipboardEvent = 1818,
  ClipboardItem = 1833,
  ClonedErrorHolder = 1847,
  CloseEvent = 1865,
  CommandEvent = 1876,
  Comment = 1889,
  CompositionEvent = 1897,
  CompressionStream = 1914,
  ConsoleInstance = 1932,
  ConstantSourceNode = 1948,
  ContentFrameMessageManager = 1967,
  ContentProcessMessageManager = 1994,
  ContentVisibilityAutoStateChangeEvent = 2023,
  ConvolverNode = 2061,
  CountQueuingStrategy = 2075,
  CreateOfferRequest = 2096,
  Credential = 2115,
  CredentialsContainer = 2126,
  Crypto = 2147,
  CryptoKey = 2154,
  CustomElementRegistry = 2164,
  CustomEvent = 2186,
  CustomStateSet = 2198,
  DOMException = 2213,
  DOMImplementation = 2226,
  DOMLocalization = 2244,
  DOMMatrix = 2260,
  DOMMatrixReadOnly = 2270,
  DOMParser = 2288,
  DOMPoint = 2298,
  DOMPointReadOnly = 2307,
  DOMQuad = 2324,
  DOMRect = 2332,
  DOMRectList = 2340,
  DOMRectReadOnly = 2352,
  DOMStringList = 2368,
  DOMStringMap = 2382,
  DOMTokenList = 2395,
  DataTransfer = 2408,
  DataTransferItem = 2421,
  DataTransferItemList = 2438,
  DebuggerNotification = 2459,
  DebuggerNotificationObserver = 2480,
  DecompressionStream = 2509,
  DedicatedWorkerGlobalScope = 2529,
  DelayNode = 2556,
  DeprecationReportBody = 2566,
  DeviceAcceleration = 2588,
  DeviceLightEvent = 2607,
  DeviceMotionEvent = 2624,
  DeviceOrientationEvent = 2642,
  DeviceRotationRate = 2665,
  Directory = 2684,
  Document = 2694,
  DocumentFragment = 2703,
  DocumentL10n = 2720,
  DocumentTimeline = 2733,
  DocumentType = 2750,
  DominatorTree = 2763,
  DragEvent = 2777,
  DynamicsCompressorNode = 2787,
  EXT_blend_minmax = 2810,
  EXT_color_buffer_float = 2827,
  EXT_color_buffer_half_float = 2850,
  EXT_disjoint_timer_query = 2878,
  EXT_float_blend = 2903,
  EXT_frag_depth = 2919,
  EXT_sRGB = 2934,
  EXT_shader_texture_lod = 2943,
  EXT_texture_compression_bptc = 2966,
  EXT_texture_compression_rgtc = 2995,
  EXT_texture_filter_anisotropic = 3024,
  EXT_texture_norm16 = 3055,
  Element = 3074,
  ElementInternals = 3082,
  EncodedAudioChunk = 3099,
  EncodedVideoChunk = 3117,
  ErrorEvent = 3135,
  Event = 3146,
  EventCallbackDebuggerNotification = 3152,
  EventCounts = 3186,
  EventSource = 3198,
  EventTarget = 3210,
  Exception = 3222,
  ExtendableEvent = 3232,
  ExtendableMessageEvent = 3248,
  ExtensionAlarms = 3271,
  ExtensionBrowser = 3287,
  ExtensionBrowserSettings = 3304,
  ExtensionBrowserSettingsColorManagement = 3329,
  ExtensionDns = 3369,
  ExtensionEventManager = 3382,
  ExtensionMockAPI = 3404,
  ExtensionPort = 3421,
  ExtensionProxy = 3435,
  ExtensionRuntime = 3450,
  ExtensionScripting = 3467,
  ExtensionSetting = 3486,
  ExtensionTest = 3503,
  External = 3517,
  FeaturePolicy = 3526,
  FeaturePolicyViolationReportBody = 3540,
  FetchEvent = 3573,
  FetchObserver = 3584,
  File = 3598,
  FileList = 3603,
  FileReader = 3612,
  FileReaderSync = 3623,
  FileSystem = 3638,
  FileSystemDirectoryEntry = 3649,
  FileSystemDirectoryHandle = 3674,
  FileSystemDirectoryHandle_AsyncIterator = 3700,
  FileSystemDirectoryIterator = 3740,
  FileSystemDirectoryReader = 3768,
  FileSystemEntry = 3794,
  FileSystemFileEntry = 3810,
  FileSystemFileHandle = 3830,
  FileSystemHandle = 3851,
  FileSystemSyncAccessHandle = 3868,
  FileSystemWritableFileStream = 3895,
  Flex = 3924,
  FlexItemValues = 3929,
  FlexLineValues = 3944,
  FluentBundle = 3959,
  FluentBundleAsyncIterator = 3972,
  FluentBundleIterator = 3998,
  FluentPattern = 4019,
  FluentResource = 4033,
  FocusEvent = 4048,
  FontFace = 4059,
  FontFaceSet = 4068,
  FontFaceSetIterator = 4080,
  FontFaceSetLoadEvent = 4100,
  FormData = 4121,
  FormData_Iterator = 4130,
  FormDataEvent = 4148,
  FragmentDirective = 4162,
  FrameCrashedEvent = 4180,
  FrameLoader = 4198,
  GPU = 4210,
  GPUAdapter = 4214,
  GPUAdapterInfo = 4225,
  GPUBindGroup = 4240,
  GPUBindGroupLayout = 4253,
  GPUBuffer = 4272,
  GPUBufferUsage = 4282,
  GPUCanvasContext = 4297,
  GPUColorWrite = 4314,
  GPUCommandBuffer = 4328,
  GPUCommandEncoder = 4345,
  GPUCompilationInfo = 4363,
  GPUCompilationMessage = 4382,
  GPUComputePassEncoder = 4404,
  GPUComputePipeline = 4426,
  GPUDevice = 4445,
  GPUDeviceLostInfo = 4455,
  GPUError = 4473,
  GPUInternalError = 4482,
  GPUMapMode = 4499,
  GPUOutOfMemoryError = 4510,
  GPUPipelineLayout = 4530,
  GPUQuerySet = 4548,
  GPUQueue = 4560,
  GPURenderBundle = 4569,
  GPURenderBundleEncoder = 4585,
  GPURenderPassEncoder = 4608,
  GPURenderPipeline = 4629,
  GPUSampler = 4647,
  GPUShaderModule = 4658,
  GPUShaderStage = 4674,
  GPUSupportedFeatures = 4689,
  GPUSupportedLimits = 4710,
  GPUTexture = 4729,
  GPUTextureUsage = 4740,
  GPUTextureView = 4756,
  GPUUncapturedErrorEvent = 4771,
  GPUValidationError = 4795,
  GainNode = 4814,
  Gamepad = 4823,
  GamepadAxisMoveEvent = 4831,
  GamepadButton = 4852,
  GamepadButtonEvent = 4866,
  GamepadEvent = 4885,
  GamepadHapticActuator = 4898,
  GamepadLightIndicator = 4920,
  GamepadPose = 4942,
  GamepadServiceTest = 4954,
  GamepadTouch = 4973,
  Geolocation = 4986,
  GeolocationCoordinates = 4998,
  GeolocationPosition = 5021,
  GeolocationPositionError = 5041,
  GetUserMediaRequest = 5066,
  GleanBoolean = 5086,
  GleanCategory = 5099,
  GleanCounter = 5113,
  GleanCustomDistribution = 5126,
  GleanDatetime = 5150,
  GleanDenominator = 5164,
  GleanEvent = 5181,
  GleanImpl = 5192,
  GleanLabeled = 5202,
  GleanMemoryDistribution = 5215,
  GleanMetric = 5239,
  GleanNumerator = 5251,
  GleanObject = 5266,
  GleanPingsImpl = 5278,
  GleanQuantity = 5293,
  GleanRate = 5307,
  GleanString = 5317,
  GleanStringList = 5329,
  GleanText = 5345,
  GleanTimespan = 5355,
  GleanTimingDistribution = 5369,
  GleanUrl = 5393,
  GleanUuid = 5402,
  Grid = 5412,
  GridArea = 5417,
  GridDimension = 5426,
  GridLine = 5440,
  GridLines = 5449,
  GridTrack = 5459,
  GridTracks = 5469,
  HTMLAllCollection = 5480,
  HTMLAnchorElement = 5498,
  HTMLAreaElement = 5516,
  HTMLAudioElement = 5532,
  HTMLBRElement = 5549,
  HTMLBaseElement = 5563,
  HTMLBodyElement = 5579,
  HTMLButtonElement = 5595,
  HTMLCanvasElement = 5613,
  HTMLCollection = 5631,
  HTMLDListElement = 5646,
  HTMLDataElement = 5663,
  HTMLDataListElement = 5679,
  HTMLDetailsElement = 5699,
  HTMLDialogElement = 5718,
  HTMLDirectoryElement = 5736,
  HTMLDivElement = 5757,
  HTMLDocument = 5772,
  HTMLElement = 5785,
  HTMLEmbedElement = 5797,
  HTMLFieldSetElement = 5814,
  HTMLFontElement = 5834,
  HTMLFormControlsCollection = 5850,
  HTMLFormElement = 5877,
  HTMLFrameElement = 5893,
  HTMLFrameSetElement = 5910,
  HTMLHRElement = 5930,
  HTMLHeadElement = 5944,
  HTMLHeadingElement = 5960,
  HTMLHtmlElement = 5979,
  HTMLIFrameElement = 5995,
  HTMLImageElement = 6013,
  HTMLInputElement = 6030,
  HTMLLIElement = 6047,
  HTMLLabelElement = 6061,
  HTMLLegendElement = 6078,
  HTMLLinkElement = 6096,
  HTMLMapElement = 6112,
  HTMLMarqueeElement = 6127,
  HTMLMediaElement = 6146,
  HTMLMenuElement = 6163,
  HTMLMetaElement = 6179,
  HTMLMeterElement = 6195,
  HTMLModElement = 6212,
  HTMLOListElement = 6227,
  HTMLObjectElement = 6244,
  HTMLOptGroupElement = 6262,
  HTMLOptionElement = 6282,
  HTMLOptionsCollection = 6300,
  HTMLOutputElement = 6322,
  HTMLParagraphElement = 6340,
  HTMLParamElement = 6361,
  HTMLPictureElement = 6378,
  HTMLPreElement = 6397,
  HTMLProgressElement = 6412,
  HTMLQuoteElement = 6432,
  HTMLScriptElement = 6449,
  HTMLSelectElement = 6467,
  HTMLSlotElement = 6485,
  HTMLSourceElement = 6501,
  HTMLSpanElement = 6519,
  HTMLStyleElement = 6535,
  HTMLTableCaptionElement = 6552,
  HTMLTableCellElement = 6576,
  HTMLTableColElement = 6597,
  HTMLTableElement = 6617,
  HTMLTableRowElement = 6634,
  HTMLTableSectionElement = 6654,
  HTMLTemplateElement = 6678,
  HTMLTextAreaElement = 6698,
  HTMLTimeElement = 6718,
  HTMLTitleElement = 6734,
  HTMLTrackElement = 6751,
  HTMLUListElement = 6768,
  HTMLUnknownElement = 6785,
  HTMLVideoElement = 6804,
  HashChangeEvent = 6821,
  Headers = 6837,
  Headers_Iterator = 6845,
  HeapSnapshot = 6862,
  Highlight = 6875,
  HighlightRegistry = 6885,
  History = 6903,
  IDBCursor = 6911,
  IDBCursorWithValue = 6921,
  IDBDatabase = 6940,
  IDBFactory = 6952,
  IDBIndex = 6963,
  IDBKeyRange = 6972,
  IDBObjectStore = 6984,
  IDBOpenDBRequest = 6999,
  IDBRequest = 7016,
  IDBTransaction = 7027,
  IDBVersionChangeEvent = 7042,
  IIRFilterNode = 7064,
  IOUtils = 7078,
  IdentityCredential = 7086,
  IdleDeadline = 7105,
  Image = 7118,
  ImageBitmap = 7124,
  ImageBitmapRenderingContext = 7136,
  ImageCapture = 7164,
  ImageCaptureError = 7177,
  ImageCaptureErrorEvent = 7195,
  ImageData = 7218,
  ImageDocument = 7228,
  InputEvent = 7242,
  InspectorCSSParser = 7253,
  InspectorFontFace = 7272,
  InspectorUtils = 7290,
  InstallTriggerImpl = 7305,
  IntersectionObserver = 7324,
  IntersectionObserverEntry = 7345,
  IntlUtils = 7371,
  InvokeEvent = 7381,
  JSProcessActorChild = 7393,
  JSProcessActorParent = 7413,
  JSWindowActorChild = 7434,
  JSWindowActorParent = 7453,
  KeyEvent = 7473,
  KeyboardEvent = 7482,
  KeyframeEffect = 7496,
  L10nFileSource = 7511,
  L10nOverlays = 7526,
  L10nRegistry = 7539,
  LargestContentfulPaint = 7552,
  LegacyMozTCPSocket = 7575,
  Localization = 7594,
  Location = 7607,
  Lock = 7616,
  LockManager = 7621,
  MIDIAccess = 7633,
  MIDIConnectionEvent = 7644,
  MIDIInput = 7664,
  MIDIInputMap = 7674,
  MIDIMessageEvent = 7687,
  MIDIOutput = 7704,
  MIDIOutputMap = 7715,
  MIDIPort = 7729,
  MOZ_debug = 7738,
  MatchGlob = 7748,
  MatchPattern = 7758,
  MatchPatternSet = 7771,
  MathMLElement = 7787,
  MediaCapabilities = 7801,
  MediaCapabilitiesInfo = 7819,
  MediaControlService = 7841,
  MediaController = 7861,
  MediaDeviceInfo = 7877,
  MediaDevices = 7893,
  MediaElementAudioSourceNode = 7906,
  MediaEncryptedEvent = 7934,
  MediaError = 7954,
  MediaKeyError = 7965,
  MediaKeyMessageEvent = 7979,
  MediaKeySession = 8000,
  MediaKeyStatusMap = 8016,
  MediaKeyStatusMap_Iterator = 8034,
  MediaKeySystemAccess = 8061,
  MediaKeys = 8082,
  MediaList = 8092,
  MediaMetadata = 8102,
  MediaQueryList = 8116,
  MediaQueryListEvent = 8131,
  MediaRecorder = 8151,
  MediaRecorderErrorEvent = 8165,
  MediaSession = 8189,
  MediaSource = 8202,
  MediaStream = 8214,
  MediaStreamAudioDestinationNode = 8226,
  MediaStreamAudioSourceNode = 8258,
  MediaStreamError = 8285,
  MediaStreamEvent = 8302,
  MediaStreamTrack = 8319,
  MediaStreamTrackAudioSourceNode = 8336,
  MediaStreamTrackEvent = 8368,
  MerchantValidationEvent = 8390,
  MessageBroadcaster = 8414,
  MessageChannel = 8433,
  MessageEvent = 8448,
  MessageListenerManager = 8461,
  MessagePort = 8484,
  MessageSender = 8496,
  MimeType = 8510,
  MimeTypeArray = 8519,
  MouseEvent = 8533,
  MouseScrollEvent = 8544,
  MozCanvasPrintState = 8561,
  MozDocumentMatcher = 8581,
  MozDocumentObserver = 8600,
  MozQueryInterface = 8620,
  MozSharedMap = 8638,
  MozSharedMap_Iterator = 8651,
  MozSharedMapChangeEvent = 8673,
  MozStorageAsyncStatementParams = 8697,
  MozStorageStatementParams = 8728,
  MozStorageStatementRow = 8754,
  MozWritableSharedMap = 8777,
  MutationEvent = 8798,
  MutationObserver = 8812,
  MutationRecord = 8829,
  NamedNodeMap = 8844,
  NavigationPreloadManager = 8857,
  Navigator = 8882,
  NetworkInformation = 8892,
  Node = 8911,
  NodeFilter = 8916,
  NodeIterator = 8927,
  NodeList = 8940,
  Notification = 8949,
  NotificationEvent = 8962,
  NotifyPaintEvent = 8980,
  OES_draw_buffers_indexed = 8997,
  OES_element_index_uint = 9022,
  OES_fbo_render_mipmap = 9045,
  OES_standard_derivatives = 9067,
  OES_texture_float = 9092,
  OES_texture_float_linear = 9110,
  OES_texture_half_float = 9135,
  OES_texture_half_float_linear = 9158,
  OES_vertex_array_object = 9188,
  OVR_multiview2 = 9212,
  OfflineAudioCompletionEvent = 9227,
  OfflineAudioContext = 9255,
  OffscreenCanvas = 9275,
  OffscreenCanvasRenderingContext2D = 9291,
  OnlyForUseInConstructor = 9325,
  Option = 9349,
  OscillatorNode = 9356,
  PageTransitionEvent = 9371,
  PaintRequest = 9391,
  PaintRequestList = 9404,
  PaintWorkletGlobalScope = 9421,
  PannerNode = 9445,
  ParentProcessMessageManager = 9456,
  Path2D = 9484,
  PathUtils = 9491,
  PaymentAddress = 9501,
  PaymentMethodChangeEvent = 9516,
  PaymentRequest = 9541,
  PaymentRequestUpdateEvent = 9556,
  PaymentResponse = 9582,
  PeerConnectionImpl = 9598,
  PeerConnectionObserver = 9617,
  Performance = 9640,
  PerformanceEntry = 9652,
  PerformanceEntryEvent = 9669,
  PerformanceEventTiming = 9691,
  PerformanceMark = 9714,
  PerformanceMeasure = 9730,
  PerformanceNavigation = 9749,
  PerformanceNavigationTiming = 9771,
  PerformanceObserver = 9799,
  PerformanceObserverEntryList = 9819,
  PerformancePaintTiming = 9848,
  PerformanceResourceTiming = 9871,
  PerformanceServerTiming = 9897,
  PerformanceTiming = 9921,
  PeriodicWave = 9939,
  PermissionStatus = 9952,
  Permissions = 9969,
  PlacesBookmark = 9981,
  PlacesBookmarkAddition = 9996,
  PlacesBookmarkChanged = 10019,
  PlacesBookmarkGuid = 10041,
  PlacesBookmarkKeyword = 10060,
  PlacesBookmarkMoved = 10082,
  PlacesBookmarkRemoved = 10102,
  PlacesBookmarkTags = 10124,
  PlacesBookmarkTime = 10143,
  PlacesBookmarkTitle = 10162,
  PlacesBookmarkUrl = 10182,
  PlacesEvent = 10200,
  PlacesEventCounts = 10212,
  PlacesFavicon = 10230,
  PlacesHistoryCleared = 10244,
  PlacesObservers = 10265,
  PlacesPurgeCaches = 10281,
  PlacesRanking = 10299,
  PlacesVisit = 10313,
  PlacesVisitRemoved = 10325,
  PlacesVisitTitle = 10344,
  PlacesWeakCallbackWrapper = 10361,
  Plugin = 10387,
  PluginArray = 10394,
  PluginCrashedEvent = 10406,
  PointerEvent = 10425,
  PopStateEvent = 10438,
  PopupBlockedEvent = 10452,
  PopupPositionedEvent = 10470,
  PositionStateEvent = 10491,
  PrecompiledScript = 10510,
  ProcessMessageManager = 10528,
  ProcessingInstruction = 10550,
  ProgressEvent = 10572,
  PromiseDebugging = 10586,
  PromiseNativeHandler = 10603,
  PromiseRejectionEvent = 10624,
  PublicKeyCredential = 10646,
  PushEvent = 10666,
  PushManager = 10676,
  PushManagerImpl = 10688,
  PushMessageData = 10704,
  PushSubscription = 10720,
  PushSubscriptionOptions = 10737,
  RTCCertificate = 10761,
  RTCDTMFSender = 10776,
  RTCDTMFToneChangeEvent = 10790,
  RTCDataChannel = 10813,
  RTCDataChannelEvent = 10828,
  RTCDtlsTransport = 10848,
  RTCEncodedAudioFrame = 10865,
  RTCEncodedVideoFrame = 10886,
  RTCIceCandidate = 10907,
  RTCIceTransport = 10923,
  RTCIdentityProviderRegistrar = 10939,
  RTCPeerConnection = 10968,
  RTCPeerConnectionIceEvent = 10986,
  RTCPeerConnectionStatic = 11012,
  RTCRtpReceiver = 11036,
  RTCRtpScriptTransform = 11051,
  RTCRtpScriptTransformer = 11073,
  RTCRtpSender = 11097,
  RTCRtpTransceiver = 11110,
  RTCSctpTransport = 11128,
  RTCSessionDescription = 11145,
  RTCStatsReport = 11167,
  RTCTrackEvent = 11182,
  RTCTransformEvent = 11196,
  RadioNodeList = 11214,
  Range = 11228,
  ReadableByteStreamController = 11234,
  ReadableStream = 11263,
  ReadableStream_AsyncIterator = 11278,
  ReadableStreamBYOBReader = 11307,
  ReadableStreamBYOBRequest = 11332,
  ReadableStreamDefaultController = 11358,
  ReadableStreamDefaultReader = 11390,
  Report = 11418,
  ReportBody = 11425,
  ReportingObserver = 11436,
  Request = 11454,
  ResizeObserver = 11462,
  ResizeObserverEntry = 11477,
  ResizeObserverSize = 11497,
  Response = 11516,
  SVGAElement = 11525,
  SVGAngle = 11537,
  SVGAnimateElement = 11546,
  SVGAnimateMotionElement = 11564,
  SVGAnimateTransformElement = 11588,
  SVGAnimatedAngle = 11615,
  SVGAnimatedBoolean = 11632,
  SVGAnimatedEnumeration = 11651,
  SVGAnimatedInteger = 11674,
  SVGAnimatedLength = 11693,
  SVGAnimatedLengthList = 11711,
  SVGAnimatedNumber = 11733,
  SVGAnimatedNumberList = 11751,
  SVGAnimatedPreserveAspectRatio = 11773,
  SVGAnimatedRect = 11804,
  SVGAnimatedString = 11820,
  SVGAnimatedTransformList = 11838,
  SVGAnimationElement = 11863,
  SVGCircleElement = 11883,
  SVGClipPathElement = 11900,
  SVGComponentTransferFunctionElement = 11919,
  SVGDefsElement = 11955,
  SVGDescElement = 11970,
  SVGElement = 11985,
  SVGEllipseElement = 11996,
  SVGFEBlendElement = 12014,
  SVGFEColorMatrixElement = 12032,
  SVGFEComponentTransferElement = 12056,
  SVGFECompositeElement = 12086,
  SVGFEConvolveMatrixElement = 12108,
  SVGFEDiffuseLightingElement = 12135,
  SVGFEDisplacementMapElement = 12163,
  SVGFEDistantLightElement = 12191,
  SVGFEDropShadowElement = 12216,
  SVGFEFloodElement = 12239,
  SVGFEFuncAElement = 12257,
  SVGFEFuncBElement = 12275,
  SVGFEFuncGElement = 12293,
  SVGFEFuncRElement = 12311,
  SVGFEGaussianBlurElement = 12329,
  SVGFEImageElement = 12354,
  SVGFEMergeElement = 12372,
  SVGFEMergeNodeElement = 12390,
  SVGFEMorphologyElement = 12412,
  SVGFEOffsetElement = 12435,
  SVGFEPointLightElement = 12454,
  SVGFESpecularLightingElement = 12477,
  SVGFESpotLightElement = 12506,
  SVGFETileElement = 12528,
  SVGFETurbulenceElement = 12545,
  SVGFilterElement = 12568,
  SVGForeignObjectElement = 12585,
  SVGGElement = 12609,
  SVGGeometryElement = 12621,
  SVGGradientElement = 12640,
  SVGGraphicsElement = 12659,
  SVGImageElement = 12678,
  SVGLength = 12694,
  SVGLengthList = 12704,
  SVGLineElement = 12718,
  SVGLinearGradientElement = 12733,
  SVGMPathElement = 12758,
  SVGMarkerElement = 12774,
  SVGMaskElement = 12791,
  SVGMatrix = 12806,
  SVGMetadataElement = 12816,
  SVGNumber = 12835,
  SVGNumberList = 12845,
  SVGPathElement = 12859,
  SVGPathSeg = 12874,
  SVGPathSegArcAbs = 12885,
  SVGPathSegArcRel = 12902,
  SVGPathSegClosePath = 12919,
  SVGPathSegCurvetoCubicAbs = 12939,
  SVGPathSegCurvetoCubicRel = 12965,
  SVGPathSegCurvetoCubicSmoothAbs = 12991,
  SVGPathSegCurvetoCubicSmoothRel = 13023,
  SVGPathSegCurvetoQuadraticAbs = 13055,
  SVGPathSegCurvetoQuadraticRel = 13085,
  SVGPathSegCurvetoQuadraticSmoothAbs = 13115,
  SVGPathSegCurvetoQuadraticSmoothRel = 13151,
  SVGPathSegLinetoAbs = 13187,
  SVGPathSegLinetoHorizontalAbs = 13207,
  SVGPathSegLinetoHorizontalRel = 13237,
  SVGPathSegLinetoRel = 13267,
  SVGPathSegLinetoVerticalAbs = 13287,
  SVGPathSegLinetoVerticalRel = 13315,
  SVGPathSegList = 13343,
  SVGPathSegMovetoAbs = 13358,
  SVGPathSegMovetoRel = 13378,
  SVGPatternElement = 13398,
  SVGPoint = 13416,
  SVGPointList = 13425,
  SVGPolygonElement = 13438,
  SVGPolylineElement = 13456,
  SVGPreserveAspectRatio = 13475,
  SVGRadialGradientElement = 13498,
  SVGRect = 13523,
  SVGRectElement = 13531,
  SVGSVGElement = 13546,
  SVGScriptElement = 13560,
  SVGSetElement = 13577,
  SVGStopElement = 13591,
  SVGStringList = 13606,
  SVGStyleElement = 13620,
  SVGSwitchElement = 13636,
  SVGSymbolElement = 13653,
  SVGTSpanElement = 13670,
  SVGTextContentElement = 13686,
  SVGTextElement = 13708,
  SVGTextPathElement = 13723,
  SVGTextPositioningElement = 13742,
  SVGTitleElement = 13768,
  SVGTransform = 13784,
  SVGTransformList = 13797,
  SVGUnitTypes = 13814,
  SVGUseElement = 13827,
  SVGViewElement = 13841,
  Sanitizer = 13856,
  Scheduler = 13866,
  Screen = 13876,
  ScreenLuminance = 13883,
  ScreenOrientation = 13899,
  ScriptProcessorNode = 13917,
  ScrollAreaEvent = 13937,
  ScrollViewChangeEvent = 13953,
  SecurityPolicyViolationEvent = 13975,
  Selection = 14004,
  ServiceWorker = 14014,
  ServiceWorkerContainer = 14028,
  ServiceWorkerGlobalScope = 14051,
  ServiceWorkerRegistration = 14076,
  SessionStoreFormData = 14102,
  SessionStoreScrollData = 14123,
  SessionStoreUtils = 14146,
  ShadowRealmGlobalScope = 14164,
  ShadowRoot = 14187,
  SharedWorker = 14198,
  SharedWorkerGlobalScope = 14211,
  SimpleGestureEvent = 14235,
  SourceBuffer = 14254,
  SourceBufferList = 14267,
  SpeechGrammar = 14284,
  SpeechGrammarList = 14298,
  SpeechRecognition = 14316,
  SpeechRecognitionAlternative = 14334,
  SpeechRecognitionError = 14363,
  SpeechRecognitionEvent = 14386,
  SpeechRecognitionResult = 14409,
  SpeechRecognitionResultList = 14433,
  SpeechSynthesis = 14461,
  SpeechSynthesisErrorEvent = 14477,
  SpeechSynthesisEvent = 14503,
  SpeechSynthesisUtterance = 14524,
  SpeechSynthesisVoice = 14549,
  StaticRange = 14570,
  StereoPannerNode = 14582,
  Storage = 14599,
  StorageEvent = 14607,
  StorageManager = 14620,
  StreamFilter = 14635,
  StreamFilterDataEvent = 14648,
  StructuredCloneHolder = 14670,
  StructuredCloneTester = 14692,
  StyleSheet = 14714,
  StyleSheetApplicableStateChangeEvent = 14725,
  StyleSheetList = 14762,
  StyleSheetRemovedEvent = 14777,
  SubmitEvent = 14800,
  SubtleCrypto = 14812,
  SyncMessageSender = 14825,
  SyncReadFile = 14843,
  TCPServerSocket = 14856,
  TCPServerSocketEvent = 14872,
  TCPSocket = 14893,
  TCPSocketErrorEvent = 14903,
  TCPSocketEvent = 14923,
  TaskController = 14938,
  TaskPriorityChangeEvent = 14953,
  TaskSignal = 14977,
  TelemetryStopwatch = 14988,
  TestAttributesOnTypes = 15007,
  TestCEReactionsInterface = 15029,
  TestCImplementedInterface = 15054,
  TestCImplementedInterface2 = 15080,
  TestCallbackDictUnionOverload = 15107,
  TestChildInterface = 15137,
  TestConstructorForFuncInterface = 15156,
  TestConstructorForPrefInterface = 15188,
  TestConstructorForSCInterface = 15220,
  TestCppKeywordNamedMethodsInterface = 15250,
  TestDeprecatedInterface = 15286,
  TestExampleInterface = 15310,
  TestExampleProxyInterface = 15331,
  TestExampleThrowingConstructorInterface = 15357,
  TestExampleWorkerInterface = 15397,
  TestFuncConstructorForDifferentFuncInterface = 15424,
  TestFuncConstructorForInterface = 15469,
  TestHTMLConstructorInterface = 15501,
  TestIndexedAndNamedGetterAndSetterInterface = 15530,
  TestIndexedAndNamedGetterInterface = 15574,
  TestIndexedAndNamedSetterInterface = 15609,
  TestIndexedGetterAndSetterAndNamedGetterInterface = 15644,
  TestIndexedGetterInterface = 15694,
  TestIndexedSetterInterface = 15721,
  TestInterface = 15748,
  TestInterfaceWithPromiseConstructorArg = 15762,
  TestJSImplInterface = 15801,
  TestJSImplInterface2 = 15821,
  TestJSImplInterface3 = 15842,
  TestJSImplInterface4 = 15863,
  TestJSImplInterface5 = 15884,
  TestJSImplInterface6 = 15905,
  TestJSImplNoInterfaceObject = 15926,
  TestLegacyFactoryFunctionInterface = 15954,
  TestLegacyFactoryFunctionInterface2 = 15989,
  TestNamedDeleterInterface = 16025,
  TestNamedDeleterWithRetvalInterface = 16051,
  TestNamedGetterInterface = 16087,
  TestNamedSetterInterface = 16112,
  TestNamespace = 16137,
  TestNonWrapperCacheInterface = 16151,
  TestParentInterface = 16180,
  TestPrefChromeOnlySCFuncConstructorForInterface = 16200,
  TestPrefConstructorForDifferentPrefInterface = 16248,
  TestPrefConstructorForInterface = 16293,
  TestProtoObjectHackedNamespace = 16325,
  TestRenamedInterface = 16356,
  TestRenamedNamespace = 16377,
  TestSCConstructorForInterface = 16398,
  TestSecureContextInterface = 16428,
  TestThrowingConstructorInterface = 16455,
  TestUtils = 16488,
  TestWorkerExposedInterface = 16498,
  TestingDeprecatedInterface = 16525,
  Text = 16552,
  TextClause = 16557,
  TextDecoder = 16568,
  TextDecoderStream = 16580,
  TextEncoder = 16598,
  TextEncoderStream = 16610,
  TextEvent = 16628,
  TextMetrics = 16638,
  TextTrack = 16650,
  TextTrackCue = 16660,
  TextTrackCueList = 16673,
  TextTrackList = 16690,
  TimeEvent = 16704,
  TimeRanges = 16714,
  ToggleEvent = 16725,
  Touch = 16737,
  TouchEvent = 16743,
  TouchList = 16754,
  TrackEvent = 16764,
  TransformStream = 16775,
  TransformStreamDefaultController = 16791,
  TransitionEvent = 16824,
  TreeColumn = 16840,
  TreeColumns = 16851,
  TreeContentView = 16863,
  TreeWalker = 16879,
  TrustedHTML = 16890,
  TrustedScript = 16902,
  TrustedScriptURL = 16916,
  TrustedTypePolicy = 16933,
  TrustedTypePolicyFactory = 16951,
  UDPMessageEvent = 16976,
  UDPSocket = 16992,
  UIEvent = 17002,
  URL = 17010,
  URLSearchParams = 17014,
  URLSearchParams_Iterator = 17030,
  UniFFIPointer = 17055,
  UniFFIScaffolding = 17069,
  UserActivation = 17087,
  UserInteraction = 17102,
  UserProximityEvent = 17118,
  VRDisplay = 17137,
  VRDisplayCapabilities = 17147,
  VRDisplayEvent = 17169,
  VREyeParameters = 17184,
  VRFieldOfView = 17200,
  VRFrameData = 17214,
  VRMockController = 17226,
  VRMockDisplay = 17243,
  VRPose = 17257,
  VRServiceTest = 17264,
  VRStageParameters = 17278,
  VTTCue = 17296,
  VTTRegion = 17303,
  ValidityState = 17313,
  VideoColorSpace = 17327,
  VideoDecoder = 17343,
  VideoEncoder = 17356,
  VideoFrame = 17369,
  VideoPlaybackQuality = 17380,
  VideoTrack = 17401,
  VideoTrackList = 17412,
  VisualViewport = 17427,
  WEBGL_color_buffer_float = 17442,
  WEBGL_compressed_texture_astc = 17467,
  WEBGL_compressed_texture_etc = 17497,
  WEBGL_compressed_texture_etc1 = 17526,
  WEBGL_compressed_texture_pvrtc = 17556,
  WEBGL_compressed_texture_s3tc = 17587,
  WEBGL_compressed_texture_s3tc_srgb = 17617,
  WEBGL_debug_renderer_info = 17652,
  WEBGL_debug_shaders = 17678,
  WEBGL_depth_texture = 17698,
  WEBGL_draw_buffers = 17718,
  WEBGL_explicit_present = 17737,
  WEBGL_lose_context = 17760,
  WEBGL_provoking_vertex = 17779,
  WakeLock = 17802,
  WakeLockSentinel = 17811,
  WaveShaperNode = 17828,
  WebExtensionContentScript = 17843,
  WebExtensionPolicy = 17869,
  WebGL2RenderingContext = 17888,
  WebGLActiveInfo = 17911,
  WebGLBuffer = 17927,
  WebGLContextEvent = 17939,
  WebGLFramebuffer = 17957,
  WebGLProgram = 17974,
  WebGLQuery = 17987,
  WebGLRenderbuffer = 17998,
  WebGLRenderingContext = 18016,
  WebGLSampler = 18038,
  WebGLShader = 18051,
  WebGLShaderPrecisionFormat = 18063,
  WebGLSync = 18090,
  WebGLTexture = 18100,
  WebGLTransformFeedback = 18113,
  WebGLUniformLocation = 18136,
  WebGLVertexArrayObject = 18157,
  WebKitCSSMatrix = 18180,
  WebSocket = 18196,
  WebTransport = 18206,
  WebTransportBidirectionalStream = 18219,
  WebTransportDatagramDuplexStream = 18251,
  WebTransportError = 18284,
  WebTransportReceiveStream = 18302,
  WebTransportSendStream = 18328,
  WebrtcGlobalInformation = 18351,
  WheelEvent = 18375,
  Window = 18386,
  WindowClient = 18393,
  WindowContext = 18406,
  WindowGlobalChild = 18420,
  WindowGlobalParent = 18438,
  WindowRoot = 18457,
  Worker = 18468,
  WorkerDebuggerGlobalScope = 18475,
  WorkerGlobalScope = 18501,
  WorkerLocation = 18519,
  WorkerNavigator = 18534,
  WorkerTestUtils = 18550,
  Worklet = 18566,
  WorkletGlobalScope = 18574,
  WritableStream = 18593,
  WritableStreamDefaultController = 18608,
  WritableStreamDefaultWriter = 18640,
  XMLDocument = 18668,
  XMLHttpRequest = 18680,
  XMLHttpRequestEventTarget = 18695,
  XMLHttpRequestUpload = 18721,
  XMLSerializer = 18742,
  XPathEvaluator = 18756,
  XPathExpression = 18771,
  XPathResult = 18787,
  XRBoundedReferenceSpace = 18799,
  XRFrame = 18823,
  XRInputSource = 18831,
  XRInputSourceArray = 18845,
  XRInputSourceEvent = 18864,
  XRInputSourcesChangeEvent = 18883,
  XRPose = 18909,
  XRReferenceSpace = 18916,
  XRReferenceSpaceEvent = 18933,
  XRRenderState = 18955,
  XRRigidTransform = 18969,
  XRSession = 18986,
  XRSessionEvent = 18996,
  XRSpace = 19011,
  XRSystem = 19019,
  XRView = 19028,
  XRViewerPose = 19035,
  XRViewport = 19048,
  XRWebGLLayer = 19059,
  XSLTProcessor = 19072,
  XULCommandEvent = 19086,
  XULElement = 19102,
  XULFrameElement = 19113,
  XULMenuElement = 19129,
  XULPopupElement = 19144,
  XULResizerElement = 19160,
  XULTextElement = 19178,
  XULTreeElement = 19193,
  console = 19208,
  webkitSpeechGrammar = 19216,
  webkitSpeechGrammarList = 19236,
  webkitSpeechRecognition = 19260,
  webkitURL = 19284,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // DOM_BINDINGNAMES_H_
