/* THIS FILE IS AUTOGENERATED FROM Event.webidl BY Codegen.py - DO NOT EDIT */

#ifndef DOM_EVENTBINDING_H_
#define DOM_EVENTBINDING_H_

#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"

namespace mozilla {
namespace dom {

class Event;
struct EventInitAtoms;
struct NativePropertyHooks;
class ProtoAndIfaceCache;

} // namespace dom
} // namespace mozilla

namespace mozilla::dom {

struct EventInit : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR bool mBubbles;
  MOZ_INIT_OUTSIDE_CTOR bool mCancelable;
  MOZ_INIT_OUTSIDE_CTOR bool mComposed;

  EventInit();

  explicit inline EventInit(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  EventInit(EventInit&& aOther) = default;

  explicit inline EventInit(const EventInit& aOther)
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);

  EventInit&
  operator=(const EventInit& aOther);

  bool
  operator==(const EventInit& aOther) const;

private:
  static bool
  InitIds(JSContext* cx, EventInitAtoms* atomsCache);
};

namespace binding_detail {
struct FastEventInit : public EventInit
{
  inline FastEventInit()
    : EventInit(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace Event_Binding {

  typedef mozilla::dom::Event NativeType;

  static const uint16_t NONE = 0;
  static const uint16_t CAPTURING_PHASE = 1;
  static const uint16_t AT_TARGET = 2;
  static const uint16_t BUBBLING_PHASE = 3;
  static const int32_t ALT_MASK = 1;
  static const int32_t CONTROL_MASK = 2;
  static const int32_t SHIFT_MASK = 4;
  static const int32_t META_MASK = 8;
  bool
  Wrap(JSContext* aCx, mozilla::dom::Event* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::Event,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  JSObject*
  GetProtoObject(JSContext* aCx);

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::Event,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace Event_Binding



} // namespace mozilla::dom

#endif // DOM_EVENTBINDING_H_
