/* THIS FILE IS AUTOGENERATED FROM MediaKeySystemAccess.webidl BY Codegen.py - DO NOT EDIT */

#ifndef DOM_MEDIAKEYSYSTEMACCESSBINDING_H_
#define DOM_MEDIAKEYSYSTEMACCESSBINDING_H_

#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/EnumTypeTraits.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"

namespace mozilla {
namespace dom {

class MediaKeySystemAccess;
struct MediaKeySystemConfigurationAtoms;
struct MediaKeySystemMediaCapability;
struct MediaKeySystemMediaCapabilityAtoms;
struct NativePropertyHooks;
class ProtoAndIfaceCache;

} // namespace dom
} // namespace mozilla

namespace mozilla {

namespace dom {

enum class MediaKeysRequirement : uint8_t {
  Required,
  Optional,
  Not_allowed,
};

namespace binding_detail {
template <> struct EnumStrings<MediaKeysRequirement> {
  static const nsLiteralCString Values[3];
};
} // namespace binding_detail

bool
ToJSValue(JSContext* aCx, MediaKeysRequirement aArgument, JS::MutableHandle<JS::Value> aValue);


struct MediaKeySystemMediaCapability : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR nsString mContentType;
  MOZ_INIT_OUTSIDE_CTOR nsString mEncryptionScheme;
  MOZ_INIT_OUTSIDE_CTOR nsString mRobustness;

  MediaKeySystemMediaCapability();

  explicit inline MediaKeySystemMediaCapability(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  MediaKeySystemMediaCapability(MediaKeySystemMediaCapability&& aOther) = default;

  explicit inline MediaKeySystemMediaCapability(const MediaKeySystemMediaCapability& aOther)
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);

  MediaKeySystemMediaCapability&
  operator=(const MediaKeySystemMediaCapability& aOther);

  bool
  operator==(const MediaKeySystemMediaCapability& aOther) const;

private:
  static bool
  InitIds(JSContext* cx, MediaKeySystemMediaCapabilityAtoms* atomsCache);
};

namespace binding_detail {
struct FastMediaKeySystemMediaCapability : public MediaKeySystemMediaCapability
{
  inline FastMediaKeySystemMediaCapability()
    : MediaKeySystemMediaCapability(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct MediaKeySystemConfiguration : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Sequence<MediaKeySystemMediaCapability> mAudioCapabilities;
  MOZ_INIT_OUTSIDE_CTOR MediaKeysRequirement mDistinctiveIdentifier;
  MOZ_INIT_OUTSIDE_CTOR Sequence<nsString> mInitDataTypes;
  MOZ_INIT_OUTSIDE_CTOR nsString mLabel;
  MOZ_INIT_OUTSIDE_CTOR MediaKeysRequirement mPersistentState;
  MOZ_INIT_OUTSIDE_CTOR Optional<Sequence<nsString>> mSessionTypes;
  MOZ_INIT_OUTSIDE_CTOR Sequence<MediaKeySystemMediaCapability> mVideoCapabilities;

  MediaKeySystemConfiguration();

  explicit inline MediaKeySystemConfiguration(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  MediaKeySystemConfiguration(MediaKeySystemConfiguration&& aOther) = default;

  explicit inline MediaKeySystemConfiguration(const MediaKeySystemConfiguration& aOther)
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);

  MediaKeySystemConfiguration&
  operator=(const MediaKeySystemConfiguration& aOther);

private:
  static bool
  InitIds(JSContext* cx, MediaKeySystemConfigurationAtoms* atomsCache);
};

namespace binding_detail {
struct FastMediaKeySystemConfiguration : public MediaKeySystemConfiguration
{
  inline FastMediaKeySystemConfiguration()
    : MediaKeySystemConfiguration(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace MediaKeySystemAccess_Binding {

  typedef mozilla::dom::MediaKeySystemAccess NativeType;

  bool
  Wrap(JSContext* aCx, mozilla::dom::MediaKeySystemAccess* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::MediaKeySystemAccess,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::MediaKeySystemAccess,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace MediaKeySystemAccess_Binding



} // namespace dom


template <>
struct MaxContiguousEnumValue<dom::MediaKeysRequirement>
{
  static constexpr dom::MediaKeysRequirement value = dom::MediaKeysRequirement::Not_allowed;

  static_assert(static_cast<uint8_t>(dom::MediaKeysRequirement::Required) == 0,
                "We rely on this in ContiguousEnumValues");
  static_assert(mozilla::ArrayLength(dom::binding_detail::EnumStrings<dom::MediaKeysRequirement>::Values) - 1 == UnderlyingValue(value),
                "Mismatch between enum strings and enum count");
};


} // namespace mozilla

#endif // DOM_MEDIAKEYSYSTEMACCESSBINDING_H_
