/* THIS FILE IS AUTOGENERATED FROM MediaKeys.webidl BY Codegen.py - DO NOT EDIT */

#ifndef DOM_MEDIAKEYSBINDING_H_
#define DOM_MEDIAKEYSBINDING_H_

#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/EnumTypeTraits.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"

namespace mozilla {
namespace dom {

class MediaKeys;
struct MediaKeysPolicyAtoms;
struct NativePropertyHooks;
class ProtoAndIfaceCache;

} // namespace dom
} // namespace mozilla

namespace mozilla {

namespace dom {

enum class MediaKeySessionType : uint8_t {
  Temporary,
  Persistent_license,
};

namespace binding_detail {
template <> struct EnumStrings<MediaKeySessionType> {
  static const nsLiteralCString Values[2];
};
} // namespace binding_detail

bool
ToJSValue(JSContext* aCx, MediaKeySessionType aArgument, JS::MutableHandle<JS::Value> aValue);


enum class HDCPVersion : uint8_t {
  _1_0,
  _1_1,
  _1_2,
  _1_3,
  _1_4,
  _2_0,
  _2_1,
  _2_2,
  _2_3,
};

namespace binding_detail {
template <> struct EnumStrings<HDCPVersion> {
  static const nsLiteralCString Values[9];
};
} // namespace binding_detail

bool
ToJSValue(JSContext* aCx, HDCPVersion aArgument, JS::MutableHandle<JS::Value> aValue);


struct MediaKeysPolicy : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Optional<HDCPVersion> mMinHdcpVersion;

  MediaKeysPolicy();

  explicit inline MediaKeysPolicy(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  MediaKeysPolicy(MediaKeysPolicy&& aOther) = default;

  explicit inline MediaKeysPolicy(const MediaKeysPolicy& aOther)
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  MediaKeysPolicy&
  operator=(const MediaKeysPolicy& aOther);

private:
  static bool
  InitIds(JSContext* cx, MediaKeysPolicyAtoms* atomsCache);
};

namespace binding_detail {
struct FastMediaKeysPolicy : public MediaKeysPolicy
{
  inline FastMediaKeysPolicy()
    : MediaKeysPolicy(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace MediaKeys_Binding {

  typedef mozilla::dom::MediaKeys NativeType;

  bool
  Wrap(JSContext* aCx, mozilla::dom::MediaKeys* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::MediaKeys,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::MediaKeys,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace MediaKeys_Binding



} // namespace dom


template <>
struct MaxContiguousEnumValue<dom::MediaKeySessionType>
{
  static constexpr dom::MediaKeySessionType value = dom::MediaKeySessionType::Persistent_license;

  static_assert(static_cast<uint8_t>(dom::MediaKeySessionType::Temporary) == 0,
                "We rely on this in ContiguousEnumValues");
  static_assert(mozilla::ArrayLength(dom::binding_detail::EnumStrings<dom::MediaKeySessionType>::Values) - 1 == UnderlyingValue(value),
                "Mismatch between enum strings and enum count");
};

template <>
struct MaxContiguousEnumValue<dom::HDCPVersion>
{
  static constexpr dom::HDCPVersion value = dom::HDCPVersion::_2_3;

  static_assert(static_cast<uint8_t>(dom::HDCPVersion::_1_0) == 0,
                "We rely on this in ContiguousEnumValues");
  static_assert(mozilla::ArrayLength(dom::binding_detail::EnumStrings<dom::HDCPVersion>::Values) - 1 == UnderlyingValue(value),
                "Mismatch between enum strings and enum count");
};


} // namespace mozilla

#endif // DOM_MEDIAKEYSBINDING_H_
