/* THIS FILE IS AUTOGENERATED FROM WebExtensionPolicy.webidl BY Codegen.py - DO NOT EDIT */

#ifndef DOM_WEBEXTENSIONPOLICYBINDING_H_
#define DOM_WEBEXTENSIONPOLICYBINDING_H_

#include "WebExtensionContentScriptBinding.h"
#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/CallbackFunction.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/Promise.h"
#include "mozilla/dom/PrototypeList.h"
#include "mozilla/dom/ToJSValue.h"

namespace mozilla {

namespace dom {

class MatchGlobOrUTF8String;
class MatchPatternSetOrStringSequence;
struct NativePropertyHooks;
class OwningMatchGlobOrUTF8String;
class OwningMatchPatternSetOrStringSequence;
class Promise;
class ProtoAndIfaceCache;
struct WebAccessibleResourceInit;
struct WebAccessibleResourceInitAtoms;
struct WebExtensionContentScriptInit;
struct WebExtensionInitAtoms;
class WebExtensionLocalizeCallback;

} // namespace dom

namespace extensions {

class WebExtensionPolicy;

} // namespace extensions

} // namespace mozilla

namespace mozilla::dom {

struct WebAccessibleResourceInit : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Nullable<Sequence<nsString>> mExtension_ids;
  MOZ_INIT_OUTSIDE_CTOR Nullable<OwningMatchPatternSetOrStringSequence > mMatches;
  MOZ_INIT_OUTSIDE_CTOR Sequence<OwningMatchGlobOrUTF8String> mResources;

  WebAccessibleResourceInit();

  explicit inline WebAccessibleResourceInit(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  WebAccessibleResourceInit(WebAccessibleResourceInit&& aOther) = default;

  explicit inline WebAccessibleResourceInit(const WebAccessibleResourceInit& aOther)
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  inline void
  TraverseForCC(nsCycleCollectionTraversalCallback& aCallback, uint32_t aFlags)
  {
    ImplCycleCollectionTraverse(aCallback, mMatches, "mMatches", aFlags);
    ImplCycleCollectionTraverse(aCallback, mResources, "mResources", aFlags);
  }

  inline void
  UnlinkForCC()
  {
    ImplCycleCollectionUnlink(mMatches);
    ImplCycleCollectionUnlink(mResources);
  }

  WebAccessibleResourceInit&
  operator=(const WebAccessibleResourceInit& aOther);

private:
  static bool
  InitIds(JSContext* cx, WebAccessibleResourceInitAtoms* atomsCache);
};

namespace binding_detail {
struct FastWebAccessibleResourceInit : public WebAccessibleResourceInit
{
  inline FastWebAccessibleResourceInit()
    : WebAccessibleResourceInit(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


class WebExtensionLocalizeCallback : public CallbackFunction
{
public:
  explicit inline WebExtensionLocalizeCallback(JSContext* aCx, JS::Handle<JSObject*> aCallback, JS::Handle<JSObject*> aCallbackGlobal, nsIGlobalObject* aIncumbentGlobal)
    : CallbackFunction(aCx, aCallback, aCallbackGlobal, aIncumbentGlobal)
  {
    MOZ_ASSERT(JS::IsCallable(mCallback));
  }

  explicit inline WebExtensionLocalizeCallback(JSObject* aCallback, JSObject* aCallbackGlobal, const FastCallbackConstructor& )
    : CallbackFunction(aCallback, aCallbackGlobal, FastCallbackConstructor())
  {
    MOZ_ASSERT(JS::IsCallable(mCallback));
  }

  explicit inline WebExtensionLocalizeCallback(JSObject* aCallback, JSObject* aCallbackGlobal, JSObject* aAsyncStack, nsIGlobalObject* aIncumbentGlobal)
    : CallbackFunction(aCallback, aCallbackGlobal, aAsyncStack, aIncumbentGlobal)
  {
    MOZ_ASSERT(JS::IsCallable(mCallback));
  }

  explicit inline WebExtensionLocalizeCallback(CallbackFunction* aOther)
    : CallbackFunction(aOther)
  {
  }

  template <typename T>
  MOZ_CAN_RUN_SCRIPT inline void
  Call(const T& thisVal, const nsAString& unlocalizedText, nsString& aRetVal, ErrorResult& aRv, const char* aExecutionReason = nullptr, ExceptionHandling aExceptionHandling = eReportExceptions, JS::Realm* aRealm = nullptr)
  {
    MOZ_ASSERT(!aRv.Failed(), "Don't pass an already-failed ErrorResult to a callback!");
    if (!aExecutionReason) {
      aExecutionReason = "WebExtensionLocalizeCallback";
    }
    CallSetup s(this, aRv, aExecutionReason, aExceptionHandling, aRealm);
    if (!s.GetContext()) {
      MOZ_ASSERT(aRv.Failed());
      return;
    }
    JS::Rooted<JS::Value> thisValJS(s.GetContext());
    if (!ToJSValue(s.GetContext(), thisVal, &thisValJS)) {
      aRv.Throw(NS_ERROR_FAILURE);
      return;
    }
    return Call(s.GetCallContext(), thisValJS, unlocalizedText, aRetVal, aRv);
  }

  MOZ_CAN_RUN_SCRIPT inline void
  Call(const nsAString& unlocalizedText, nsString& aRetVal, ErrorResult& aRv, const char* aExecutionReason = nullptr, ExceptionHandling aExceptionHandling = eReportExceptions, JS::Realm* aRealm = nullptr)
  {
    MOZ_ASSERT(!aRv.Failed(), "Don't pass an already-failed ErrorResult to a callback!");
    if (!aExecutionReason) {
      aExecutionReason = "WebExtensionLocalizeCallback";
    }
    CallSetup s(this, aRv, aExecutionReason, aExceptionHandling, aRealm);
    if (!s.GetContext()) {
      MOZ_ASSERT(aRv.Failed());
      return;
    }
    return Call(s.GetCallContext(), JS::UndefinedHandleValue, unlocalizedText, aRetVal, aRv);
  }

  template <typename T>
  MOZ_CAN_RUN_SCRIPT inline void
  Call(const T& thisVal, const nsAString& unlocalizedText, nsString& aRetVal, const char* aExecutionReason = nullptr)
  {
    return Call(thisVal, unlocalizedText, aRetVal, IgnoreErrors(), aExecutionReason);
  }

  MOZ_CAN_RUN_SCRIPT inline void
  Call(const nsAString& unlocalizedText, nsString& aRetVal, const char* aExecutionReason = nullptr)
  {
    return Call(unlocalizedText, aRetVal, IgnoreErrors(), aExecutionReason, eReportExceptions, nullptr);
  }

  inline bool
  operator==(const WebExtensionLocalizeCallback& aOther) const
  {
    return CallbackFunction::operator==(aOther);
  }

private:
  MOZ_CAN_RUN_SCRIPT void Call(BindingCallContext& cx, JS::Handle<JS::Value> aThisVal, const nsAString& unlocalizedText, nsString& aRetVal, ErrorResult& aRv);
};


namespace binding_detail {
class FastWebExtensionLocalizeCallback : public WebExtensionLocalizeCallback
{
public:
  explicit inline FastWebExtensionLocalizeCallback(JSObject* aCallback, JSObject* aCallbackGlobal)
    : WebExtensionLocalizeCallback(aCallback, aCallbackGlobal, FastCallbackConstructor())
  {
  }

  inline void
  Trace(JSTracer* aTracer)
  {
    WebExtensionLocalizeCallback::Trace(aTracer);
  }

  inline void
  FinishSlowJSInitIfMoreThanOneOwner(JSContext* aCx)
  {
    WebExtensionLocalizeCallback::FinishSlowJSInitIfMoreThanOneOwner(aCx);
  }
};
} // namespace binding_detail


struct WebExtensionInit : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR OwningMatchPatternSetOrStringSequence mAllowedOrigins;
  MOZ_INIT_OUTSIDE_CTOR Nullable<Sequence<nsString>> mBackgroundScripts;
  MOZ_INIT_OUTSIDE_CTOR bool mBackgroundTypeModule;
  MOZ_INIT_OUTSIDE_CTOR nsString mBackgroundWorkerScript;
  MOZ_INIT_OUTSIDE_CTOR nsString mBaseURL;
  MOZ_INIT_OUTSIDE_CTOR Sequence<WebExtensionContentScriptInit> mContentScripts;
  MOZ_INIT_OUTSIDE_CTOR nsString mExtensionPageCSP;
  MOZ_INIT_OUTSIDE_CTOR nsString mId;
  MOZ_INIT_OUTSIDE_CTOR bool mIgnoreQuarantine;
  MOZ_INIT_OUTSIDE_CTOR bool mIsPrivileged;
  MOZ_INIT_OUTSIDE_CTOR OwningNonNull<WebExtensionLocalizeCallback> mLocalizeCallback;
  MOZ_INIT_OUTSIDE_CTOR uint32_t mManifestVersion;
  MOZ_INIT_OUTSIDE_CTOR nsCString mMozExtensionHostname;
  MOZ_INIT_OUTSIDE_CTOR nsString mName;
  MOZ_INIT_OUTSIDE_CTOR Sequence<nsString> mPermissions;
  MOZ_INIT_OUTSIDE_CTOR Optional<OwningNonNull<Promise>> mReadyPromise;
  MOZ_INIT_OUTSIDE_CTOR bool mTemporarilyInstalled;
  MOZ_INIT_OUTSIDE_CTOR nsString mType;
  MOZ_INIT_OUTSIDE_CTOR Sequence<WebAccessibleResourceInit> mWebAccessibleResources;

  WebExtensionInit();

  explicit inline WebExtensionInit(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  WebExtensionInit(WebExtensionInit&& aOther) = default;

private:
  WebExtensionInit(const WebExtensionInit&) = delete;
  WebExtensionInit& operator=(const WebExtensionInit&) = delete;

  static bool
  InitIds(JSContext* cx, WebExtensionInitAtoms* atomsCache);

public:
  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  inline void
  TraverseForCC(nsCycleCollectionTraversalCallback& aCallback, uint32_t aFlags)
  {
    ImplCycleCollectionTraverse(aCallback, mAllowedOrigins, "mAllowedOrigins", aFlags);
    ImplCycleCollectionTraverse(aCallback, mContentScripts, "mContentScripts", aFlags);
    ImplCycleCollectionTraverse(aCallback, mLocalizeCallback, "mLocalizeCallback", aFlags);
    ImplCycleCollectionTraverse(aCallback, mReadyPromise, "mReadyPromise", aFlags);
    ImplCycleCollectionTraverse(aCallback, mWebAccessibleResources, "mWebAccessibleResources", aFlags);
  }

  inline void
  UnlinkForCC()
  {
    ImplCycleCollectionUnlink(mAllowedOrigins);
    ImplCycleCollectionUnlink(mContentScripts);
    ImplCycleCollectionUnlink(mLocalizeCallback);
    ImplCycleCollectionUnlink(mReadyPromise);
    ImplCycleCollectionUnlink(mWebAccessibleResources);
  }
};

namespace binding_detail {
struct FastWebExtensionInit : public WebExtensionInit
{
  inline FastWebExtensionInit()
    : WebExtensionInit(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace WebExtensionPolicy_Binding {

  typedef mozilla::extensions::WebExtensionPolicy NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  bool
  Wrap(JSContext* aCx, mozilla::extensions::WebExtensionPolicy* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  ClearCachedPermissionsValue(mozilla::extensions::WebExtensionPolicy* aObject);

  void
  ClearCachedContentScriptsValue(mozilla::extensions::WebExtensionPolicy* aObject);

  void
  ClearCachedIgnoreQuarantineValue(mozilla::extensions::WebExtensionPolicy* aObject);

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::WebExtensionPolicy,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::WebExtensionPolicy,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace WebExtensionPolicy_Binding



} // namespace mozilla::dom

#endif // DOM_WEBEXTENSIONPOLICYBINDING_H_
