#include "mozilla/EnumTypeTraits.h"
#include "mozilla/dom/BindingNames.h"

namespace mozilla::dom {

namespace binding_detail {

const char sBindingNames[] = {
  /*     0 */ "ANGLE_instanced_arrays" "\0"
  /*    23 */ "APZHitResultFlags" "\0"
  /*    41 */ "AbortController" "\0"
  /*    57 */ "AbortSignal" "\0"
  /*    69 */ "AbstractRange" "\0"
  /*    83 */ "AccessibleNode" "\0"
  /*    98 */ "Addon" "\0"
  /*   104 */ "AddonEvent" "\0"
  /*   115 */ "AddonInstall" "\0"
  /*   128 */ "AddonManager" "\0"
  /*   141 */ "AddonManagerPermissions" "\0"
  /*   165 */ "AnalyserNode" "\0"
  /*   178 */ "Animation" "\0"
  /*   188 */ "AnimationEffect" "\0"
  /*   204 */ "AnimationEvent" "\0"
  /*   219 */ "AnimationPlaybackEvent" "\0"
  /*   242 */ "AnimationTimeline" "\0"
  /*   260 */ "AnonymousContent" "\0"
  /*   277 */ "Attr" "\0"
  /*   282 */ "Audio" "\0"
  /*   288 */ "AudioBuffer" "\0"
  /*   300 */ "AudioBufferSourceNode" "\0"
  /*   322 */ "AudioContext" "\0"
  /*   335 */ "AudioData" "\0"
  /*   345 */ "AudioDecoder" "\0"
  /*   358 */ "AudioDestinationNode" "\0"
  /*   379 */ "AudioEncoder" "\0"
  /*   392 */ "AudioListener" "\0"
  /*   406 */ "AudioNode" "\0"
  /*   416 */ "AudioParam" "\0"
  /*   427 */ "AudioParamMap" "\0"
  /*   441 */ "AudioProcessingEvent" "\0"
  /*   462 */ "AudioScheduledSourceNode" "\0"
  /*   487 */ "AudioTrack" "\0"
  /*   498 */ "AudioTrackList" "\0"
  /*   513 */ "AudioWorklet" "\0"
  /*   526 */ "AudioWorkletGlobalScope" "\0"
  /*   550 */ "AudioWorkletNode" "\0"
  /*   567 */ "AudioWorkletProcessor" "\0"
  /*   589 */ "AuthenticatorAssertionResponse" "\0"
  /*   620 */ "AuthenticatorAttestationResponse" "\0"
  /*   653 */ "AuthenticatorResponse" "\0"
  /*   675 */ "BarProp" "\0"
  /*   683 */ "BaseAudioContext" "\0"
  /*   700 */ "BatteryManager" "\0"
  /*   715 */ "BeforeUnloadEvent" "\0"
  /*   733 */ "BiquadFilterNode" "\0"
  /*   750 */ "Blob" "\0"
  /*   755 */ "BlobEvent" "\0"
  /*   765 */ "BroadcastChannel" "\0"
  /*   782 */ "BrowsingContext" "\0"
  /*   798 */ "BrowsingContextGroup" "\0"
  /*   819 */ "ByteLengthQueuingStrategy" "\0"
  /*   845 */ "CDATASection" "\0"
  /*   858 */ "CSS" "\0"
  /*   862 */ "CSS2Properties" "\0"
  /*   877 */ "CSSAnimation" "\0"
  /*   890 */ "CSSConditionRule" "\0"
  /*   907 */ "CSSContainerRule" "\0"
  /*   924 */ "CSSCounterStyleRule" "\0"
  /*   944 */ "CSSCustomPropertyRegisteredEvent" "\0"
  /*   977 */ "CSSFontFaceRule" "\0"
  /*   993 */ "CSSFontFeatureValuesRule" "\0"
  /*  1018 */ "CSSFontPaletteValuesRule" "\0"
  /*  1043 */ "CSSGroupingRule" "\0"
  /*  1059 */ "CSSImportRule" "\0"
  /*  1073 */ "CSSKeyframeRule" "\0"
  /*  1089 */ "CSSKeyframesRule" "\0"
  /*  1106 */ "CSSLayerBlockRule" "\0"
  /*  1124 */ "CSSLayerStatementRule" "\0"
  /*  1146 */ "CSSMarginRule" "\0"
  /*  1160 */ "CSSMediaRule" "\0"
  /*  1173 */ "CSSMozDocumentRule" "\0"
  /*  1192 */ "CSSNamespaceRule" "\0"
  /*  1209 */ "CSSPageRule" "\0"
  /*  1221 */ "CSSPropertyRule" "\0"
  /*  1237 */ "CSSPseudoElement" "\0"
  /*  1254 */ "CSSRule" "\0"
  /*  1262 */ "CSSRuleList" "\0"
  /*  1274 */ "CSSScopeRule" "\0"
  /*  1287 */ "CSSStartingStyleRule" "\0"
  /*  1308 */ "CSSStyleDeclaration" "\0"
  /*  1328 */ "CSSStyleRule" "\0"
  /*  1341 */ "CSSStyleSheet" "\0"
  /*  1355 */ "CSSSupportsRule" "\0"
  /*  1371 */ "CSSTransition" "\0"
  /*  1385 */ "Cache" "\0"
  /*  1391 */ "CacheStorage" "\0"
  /*  1404 */ "CallbackDebuggerNotification" "\0"
  /*  1433 */ "CanonicalBrowsingContext" "\0"
  /*  1458 */ "CanvasCaptureMediaStream" "\0"
  /*  1483 */ "CanvasGradient" "\0"
  /*  1498 */ "CanvasPattern" "\0"
  /*  1512 */ "CanvasRenderingContext2D" "\0"
  /*  1537 */ "CaretPosition" "\0"
  /*  1551 */ "CaretStateChangedEvent" "\0"
  /*  1574 */ "ChannelMergerNode" "\0"
  /*  1592 */ "ChannelSplitterNode" "\0"
  /*  1612 */ "ChannelWrapper" "\0"
  /*  1627 */ "CharacterData" "\0"
  /*  1641 */ "CheckerboardReportService" "\0"
  /*  1667 */ "ChildProcessMessageManager" "\0"
  /*  1694 */ "ChildSHistory" "\0"
  /*  1708 */ "ChromeMessageBroadcaster" "\0"
  /*  1733 */ "ChromeMessageSender" "\0"
  /*  1753 */ "ChromeNodeList" "\0"
  /*  1768 */ "ChromeUtils" "\0"
  /*  1780 */ "ChromeWorker" "\0"
  /*  1793 */ "Client" "\0"
  /*  1800 */ "Clients" "\0"
  /*  1808 */ "Clipboard" "\0"
  /*  1818 */ "ClipboardEvent" "\0"
  /*  1833 */ "ClipboardItem" "\0"
  /*  1847 */ "ClonedErrorHolder" "\0"
  /*  1865 */ "CloseEvent" "\0"
  /*  1876 */ "CommandEvent" "\0"
  /*  1889 */ "Comment" "\0"
  /*  1897 */ "CompositionEvent" "\0"
  /*  1914 */ "CompressionStream" "\0"
  /*  1932 */ "ConsoleInstance" "\0"
  /*  1948 */ "ConstantSourceNode" "\0"
  /*  1967 */ "ContentFrameMessageManager" "\0"
  /*  1994 */ "ContentProcessMessageManager" "\0"
  /*  2023 */ "ContentVisibilityAutoStateChangeEvent" "\0"
  /*  2061 */ "ConvolverNode" "\0"
  /*  2075 */ "CountQueuingStrategy" "\0"
  /*  2096 */ "CreateOfferRequest" "\0"
  /*  2115 */ "Credential" "\0"
  /*  2126 */ "CredentialsContainer" "\0"
  /*  2147 */ "Crypto" "\0"
  /*  2154 */ "CryptoKey" "\0"
  /*  2164 */ "CustomElementRegistry" "\0"
  /*  2186 */ "CustomEvent" "\0"
  /*  2198 */ "CustomStateSet" "\0"
  /*  2213 */ "DOMException" "\0"
  /*  2226 */ "DOMImplementation" "\0"
  /*  2244 */ "DOMLocalization" "\0"
  /*  2260 */ "DOMMatrix" "\0"
  /*  2270 */ "DOMMatrixReadOnly" "\0"
  /*  2288 */ "DOMParser" "\0"
  /*  2298 */ "DOMPoint" "\0"
  /*  2307 */ "DOMPointReadOnly" "\0"
  /*  2324 */ "DOMQuad" "\0"
  /*  2332 */ "DOMRect" "\0"
  /*  2340 */ "DOMRectList" "\0"
  /*  2352 */ "DOMRectReadOnly" "\0"
  /*  2368 */ "DOMStringList" "\0"
  /*  2382 */ "DOMStringMap" "\0"
  /*  2395 */ "DOMTokenList" "\0"
  /*  2408 */ "DataTransfer" "\0"
  /*  2421 */ "DataTransferItem" "\0"
  /*  2438 */ "DataTransferItemList" "\0"
  /*  2459 */ "DebuggerNotification" "\0"
  /*  2480 */ "DebuggerNotificationObserver" "\0"
  /*  2509 */ "DecompressionStream" "\0"
  /*  2529 */ "DedicatedWorkerGlobalScope" "\0"
  /*  2556 */ "DelayNode" "\0"
  /*  2566 */ "DeprecationReportBody" "\0"
  /*  2588 */ "DeviceAcceleration" "\0"
  /*  2607 */ "DeviceLightEvent" "\0"
  /*  2624 */ "DeviceMotionEvent" "\0"
  /*  2642 */ "DeviceOrientationEvent" "\0"
  /*  2665 */ "DeviceRotationRate" "\0"
  /*  2684 */ "Directory" "\0"
  /*  2694 */ "Document" "\0"
  /*  2703 */ "DocumentFragment" "\0"
  /*  2720 */ "DocumentL10n" "\0"
  /*  2733 */ "DocumentTimeline" "\0"
  /*  2750 */ "DocumentType" "\0"
  /*  2763 */ "DominatorTree" "\0"
  /*  2777 */ "DragEvent" "\0"
  /*  2787 */ "DynamicsCompressorNode" "\0"
  /*  2810 */ "EXT_blend_minmax" "\0"
  /*  2827 */ "EXT_color_buffer_float" "\0"
  /*  2850 */ "EXT_color_buffer_half_float" "\0"
  /*  2878 */ "EXT_disjoint_timer_query" "\0"
  /*  2903 */ "EXT_float_blend" "\0"
  /*  2919 */ "EXT_frag_depth" "\0"
  /*  2934 */ "EXT_sRGB" "\0"
  /*  2943 */ "EXT_shader_texture_lod" "\0"
  /*  2966 */ "EXT_texture_compression_bptc" "\0"
  /*  2995 */ "EXT_texture_compression_rgtc" "\0"
  /*  3024 */ "EXT_texture_filter_anisotropic" "\0"
  /*  3055 */ "EXT_texture_norm16" "\0"
  /*  3074 */ "Element" "\0"
  /*  3082 */ "ElementInternals" "\0"
  /*  3099 */ "EncodedAudioChunk" "\0"
  /*  3117 */ "EncodedVideoChunk" "\0"
  /*  3135 */ "ErrorEvent" "\0"
  /*  3146 */ "Event" "\0"
  /*  3152 */ "EventCallbackDebuggerNotification" "\0"
  /*  3186 */ "EventCounts" "\0"
  /*  3198 */ "EventSource" "\0"
  /*  3210 */ "EventTarget" "\0"
  /*  3222 */ "Exception" "\0"
  /*  3232 */ "ExtendableEvent" "\0"
  /*  3248 */ "ExtendableMessageEvent" "\0"
  /*  3271 */ "ExtensionAlarms" "\0"
  /*  3287 */ "ExtensionBrowser" "\0"
  /*  3304 */ "ExtensionBrowserSettings" "\0"
  /*  3329 */ "ExtensionBrowserSettingsColorManagement" "\0"
  /*  3369 */ "ExtensionDns" "\0"
  /*  3382 */ "ExtensionEventManager" "\0"
  /*  3404 */ "ExtensionMockAPI" "\0"
  /*  3421 */ "ExtensionPort" "\0"
  /*  3435 */ "ExtensionProxy" "\0"
  /*  3450 */ "ExtensionRuntime" "\0"
  /*  3467 */ "ExtensionScripting" "\0"
  /*  3486 */ "ExtensionSetting" "\0"
  /*  3503 */ "ExtensionTest" "\0"
  /*  3517 */ "External" "\0"
  /*  3526 */ "FeaturePolicy" "\0"
  /*  3540 */ "FeaturePolicyViolationReportBody" "\0"
  /*  3573 */ "FetchEvent" "\0"
  /*  3584 */ "FetchObserver" "\0"
  /*  3598 */ "File" "\0"
  /*  3603 */ "FileList" "\0"
  /*  3612 */ "FileReader" "\0"
  /*  3623 */ "FileReaderSync" "\0"
  /*  3638 */ "FileSystem" "\0"
  /*  3649 */ "FileSystemDirectoryEntry" "\0"
  /*  3674 */ "FileSystemDirectoryHandle" "\0"
  /*  3700 */ "FileSystemDirectoryHandle AsyncIterator" "\0"
  /*  3740 */ "FileSystemDirectoryIterator" "\0"
  /*  3768 */ "FileSystemDirectoryReader" "\0"
  /*  3794 */ "FileSystemEntry" "\0"
  /*  3810 */ "FileSystemFileEntry" "\0"
  /*  3830 */ "FileSystemFileHandle" "\0"
  /*  3851 */ "FileSystemHandle" "\0"
  /*  3868 */ "FileSystemSyncAccessHandle" "\0"
  /*  3895 */ "FileSystemWritableFileStream" "\0"
  /*  3924 */ "Flex" "\0"
  /*  3929 */ "FlexItemValues" "\0"
  /*  3944 */ "FlexLineValues" "\0"
  /*  3959 */ "FluentBundle" "\0"
  /*  3972 */ "FluentBundleAsyncIterator" "\0"
  /*  3998 */ "FluentBundleIterator" "\0"
  /*  4019 */ "FluentPattern" "\0"
  /*  4033 */ "FluentResource" "\0"
  /*  4048 */ "FocusEvent" "\0"
  /*  4059 */ "FontFace" "\0"
  /*  4068 */ "FontFaceSet" "\0"
  /*  4080 */ "FontFaceSetIterator" "\0"
  /*  4100 */ "FontFaceSetLoadEvent" "\0"
  /*  4121 */ "FormData" "\0"
  /*  4130 */ "FormData Iterator" "\0"
  /*  4148 */ "FormDataEvent" "\0"
  /*  4162 */ "FragmentDirective" "\0"
  /*  4180 */ "FrameCrashedEvent" "\0"
  /*  4198 */ "FrameLoader" "\0"
  /*  4210 */ "GPU" "\0"
  /*  4214 */ "GPUAdapter" "\0"
  /*  4225 */ "GPUAdapterInfo" "\0"
  /*  4240 */ "GPUBindGroup" "\0"
  /*  4253 */ "GPUBindGroupLayout" "\0"
  /*  4272 */ "GPUBuffer" "\0"
  /*  4282 */ "GPUBufferUsage" "\0"
  /*  4297 */ "GPUCanvasContext" "\0"
  /*  4314 */ "GPUColorWrite" "\0"
  /*  4328 */ "GPUCommandBuffer" "\0"
  /*  4345 */ "GPUCommandEncoder" "\0"
  /*  4363 */ "GPUCompilationInfo" "\0"
  /*  4382 */ "GPUCompilationMessage" "\0"
  /*  4404 */ "GPUComputePassEncoder" "\0"
  /*  4426 */ "GPUComputePipeline" "\0"
  /*  4445 */ "GPUDevice" "\0"
  /*  4455 */ "GPUDeviceLostInfo" "\0"
  /*  4473 */ "GPUError" "\0"
  /*  4482 */ "GPUInternalError" "\0"
  /*  4499 */ "GPUMapMode" "\0"
  /*  4510 */ "GPUOutOfMemoryError" "\0"
  /*  4530 */ "GPUPipelineLayout" "\0"
  /*  4548 */ "GPUQuerySet" "\0"
  /*  4560 */ "GPUQueue" "\0"
  /*  4569 */ "GPURenderBundle" "\0"
  /*  4585 */ "GPURenderBundleEncoder" "\0"
  /*  4608 */ "GPURenderPassEncoder" "\0"
  /*  4629 */ "GPURenderPipeline" "\0"
  /*  4647 */ "GPUSampler" "\0"
  /*  4658 */ "GPUShaderModule" "\0"
  /*  4674 */ "GPUShaderStage" "\0"
  /*  4689 */ "GPUSupportedFeatures" "\0"
  /*  4710 */ "GPUSupportedLimits" "\0"
  /*  4729 */ "GPUTexture" "\0"
  /*  4740 */ "GPUTextureUsage" "\0"
  /*  4756 */ "GPUTextureView" "\0"
  /*  4771 */ "GPUUncapturedErrorEvent" "\0"
  /*  4795 */ "GPUValidationError" "\0"
  /*  4814 */ "GainNode" "\0"
  /*  4823 */ "Gamepad" "\0"
  /*  4831 */ "GamepadAxisMoveEvent" "\0"
  /*  4852 */ "GamepadButton" "\0"
  /*  4866 */ "GamepadButtonEvent" "\0"
  /*  4885 */ "GamepadEvent" "\0"
  /*  4898 */ "GamepadHapticActuator" "\0"
  /*  4920 */ "GamepadLightIndicator" "\0"
  /*  4942 */ "GamepadPose" "\0"
  /*  4954 */ "GamepadServiceTest" "\0"
  /*  4973 */ "GamepadTouch" "\0"
  /*  4986 */ "Geolocation" "\0"
  /*  4998 */ "GeolocationCoordinates" "\0"
  /*  5021 */ "GeolocationPosition" "\0"
  /*  5041 */ "GeolocationPositionError" "\0"
  /*  5066 */ "GetUserMediaRequest" "\0"
  /*  5086 */ "GleanBoolean" "\0"
  /*  5099 */ "GleanCategory" "\0"
  /*  5113 */ "GleanCounter" "\0"
  /*  5126 */ "GleanCustomDistribution" "\0"
  /*  5150 */ "GleanDatetime" "\0"
  /*  5164 */ "GleanDenominator" "\0"
  /*  5181 */ "GleanEvent" "\0"
  /*  5192 */ "GleanImpl" "\0"
  /*  5202 */ "GleanLabeled" "\0"
  /*  5215 */ "GleanMemoryDistribution" "\0"
  /*  5239 */ "GleanMetric" "\0"
  /*  5251 */ "GleanNumerator" "\0"
  /*  5266 */ "GleanObject" "\0"
  /*  5278 */ "GleanPingsImpl" "\0"
  /*  5293 */ "GleanQuantity" "\0"
  /*  5307 */ "GleanRate" "\0"
  /*  5317 */ "GleanString" "\0"
  /*  5329 */ "GleanStringList" "\0"
  /*  5345 */ "GleanText" "\0"
  /*  5355 */ "GleanTimespan" "\0"
  /*  5369 */ "GleanTimingDistribution" "\0"
  /*  5393 */ "GleanUrl" "\0"
  /*  5402 */ "GleanUuid" "\0"
  /*  5412 */ "Grid" "\0"
  /*  5417 */ "GridArea" "\0"
  /*  5426 */ "GridDimension" "\0"
  /*  5440 */ "GridLine" "\0"
  /*  5449 */ "GridLines" "\0"
  /*  5459 */ "GridTrack" "\0"
  /*  5469 */ "GridTracks" "\0"
  /*  5480 */ "HTMLAllCollection" "\0"
  /*  5498 */ "HTMLAnchorElement" "\0"
  /*  5516 */ "HTMLAreaElement" "\0"
  /*  5532 */ "HTMLAudioElement" "\0"
  /*  5549 */ "HTMLBRElement" "\0"
  /*  5563 */ "HTMLBaseElement" "\0"
  /*  5579 */ "HTMLBodyElement" "\0"
  /*  5595 */ "HTMLButtonElement" "\0"
  /*  5613 */ "HTMLCanvasElement" "\0"
  /*  5631 */ "HTMLCollection" "\0"
  /*  5646 */ "HTMLDListElement" "\0"
  /*  5663 */ "HTMLDataElement" "\0"
  /*  5679 */ "HTMLDataListElement" "\0"
  /*  5699 */ "HTMLDetailsElement" "\0"
  /*  5718 */ "HTMLDialogElement" "\0"
  /*  5736 */ "HTMLDirectoryElement" "\0"
  /*  5757 */ "HTMLDivElement" "\0"
  /*  5772 */ "HTMLDocument" "\0"
  /*  5785 */ "HTMLElement" "\0"
  /*  5797 */ "HTMLEmbedElement" "\0"
  /*  5814 */ "HTMLFieldSetElement" "\0"
  /*  5834 */ "HTMLFontElement" "\0"
  /*  5850 */ "HTMLFormControlsCollection" "\0"
  /*  5877 */ "HTMLFormElement" "\0"
  /*  5893 */ "HTMLFrameElement" "\0"
  /*  5910 */ "HTMLFrameSetElement" "\0"
  /*  5930 */ "HTMLHRElement" "\0"
  /*  5944 */ "HTMLHeadElement" "\0"
  /*  5960 */ "HTMLHeadingElement" "\0"
  /*  5979 */ "HTMLHtmlElement" "\0"
  /*  5995 */ "HTMLIFrameElement" "\0"
  /*  6013 */ "HTMLImageElement" "\0"
  /*  6030 */ "HTMLInputElement" "\0"
  /*  6047 */ "HTMLLIElement" "\0"
  /*  6061 */ "HTMLLabelElement" "\0"
  /*  6078 */ "HTMLLegendElement" "\0"
  /*  6096 */ "HTMLLinkElement" "\0"
  /*  6112 */ "HTMLMapElement" "\0"
  /*  6127 */ "HTMLMarqueeElement" "\0"
  /*  6146 */ "HTMLMediaElement" "\0"
  /*  6163 */ "HTMLMenuElement" "\0"
  /*  6179 */ "HTMLMetaElement" "\0"
  /*  6195 */ "HTMLMeterElement" "\0"
  /*  6212 */ "HTMLModElement" "\0"
  /*  6227 */ "HTMLOListElement" "\0"
  /*  6244 */ "HTMLObjectElement" "\0"
  /*  6262 */ "HTMLOptGroupElement" "\0"
  /*  6282 */ "HTMLOptionElement" "\0"
  /*  6300 */ "HTMLOptionsCollection" "\0"
  /*  6322 */ "HTMLOutputElement" "\0"
  /*  6340 */ "HTMLParagraphElement" "\0"
  /*  6361 */ "HTMLParamElement" "\0"
  /*  6378 */ "HTMLPictureElement" "\0"
  /*  6397 */ "HTMLPreElement" "\0"
  /*  6412 */ "HTMLProgressElement" "\0"
  /*  6432 */ "HTMLQuoteElement" "\0"
  /*  6449 */ "HTMLScriptElement" "\0"
  /*  6467 */ "HTMLSelectElement" "\0"
  /*  6485 */ "HTMLSlotElement" "\0"
  /*  6501 */ "HTMLSourceElement" "\0"
  /*  6519 */ "HTMLSpanElement" "\0"
  /*  6535 */ "HTMLStyleElement" "\0"
  /*  6552 */ "HTMLTableCaptionElement" "\0"
  /*  6576 */ "HTMLTableCellElement" "\0"
  /*  6597 */ "HTMLTableColElement" "\0"
  /*  6617 */ "HTMLTableElement" "\0"
  /*  6634 */ "HTMLTableRowElement" "\0"
  /*  6654 */ "HTMLTableSectionElement" "\0"
  /*  6678 */ "HTMLTemplateElement" "\0"
  /*  6698 */ "HTMLTextAreaElement" "\0"
  /*  6718 */ "HTMLTimeElement" "\0"
  /*  6734 */ "HTMLTitleElement" "\0"
  /*  6751 */ "HTMLTrackElement" "\0"
  /*  6768 */ "HTMLUListElement" "\0"
  /*  6785 */ "HTMLUnknownElement" "\0"
  /*  6804 */ "HTMLVideoElement" "\0"
  /*  6821 */ "HashChangeEvent" "\0"
  /*  6837 */ "Headers" "\0"
  /*  6845 */ "Headers Iterator" "\0"
  /*  6862 */ "HeapSnapshot" "\0"
  /*  6875 */ "Highlight" "\0"
  /*  6885 */ "HighlightRegistry" "\0"
  /*  6903 */ "History" "\0"
  /*  6911 */ "IDBCursor" "\0"
  /*  6921 */ "IDBCursorWithValue" "\0"
  /*  6940 */ "IDBDatabase" "\0"
  /*  6952 */ "IDBFactory" "\0"
  /*  6963 */ "IDBIndex" "\0"
  /*  6972 */ "IDBKeyRange" "\0"
  /*  6984 */ "IDBObjectStore" "\0"
  /*  6999 */ "IDBOpenDBRequest" "\0"
  /*  7016 */ "IDBRequest" "\0"
  /*  7027 */ "IDBTransaction" "\0"
  /*  7042 */ "IDBVersionChangeEvent" "\0"
  /*  7064 */ "IIRFilterNode" "\0"
  /*  7078 */ "IOUtils" "\0"
  /*  7086 */ "IdentityCredential" "\0"
  /*  7105 */ "IdleDeadline" "\0"
  /*  7118 */ "Image" "\0"
  /*  7124 */ "ImageBitmap" "\0"
  /*  7136 */ "ImageBitmapRenderingContext" "\0"
  /*  7164 */ "ImageCapture" "\0"
  /*  7177 */ "ImageCaptureError" "\0"
  /*  7195 */ "ImageCaptureErrorEvent" "\0"
  /*  7218 */ "ImageData" "\0"
  /*  7228 */ "ImageDocument" "\0"
  /*  7242 */ "InputEvent" "\0"
  /*  7253 */ "InspectorCSSParser" "\0"
  /*  7272 */ "InspectorFontFace" "\0"
  /*  7290 */ "InspectorUtils" "\0"
  /*  7305 */ "InstallTriggerImpl" "\0"
  /*  7324 */ "IntersectionObserver" "\0"
  /*  7345 */ "IntersectionObserverEntry" "\0"
  /*  7371 */ "IntlUtils" "\0"
  /*  7381 */ "InvokeEvent" "\0"
  /*  7393 */ "JSProcessActorChild" "\0"
  /*  7413 */ "JSProcessActorParent" "\0"
  /*  7434 */ "JSWindowActorChild" "\0"
  /*  7453 */ "JSWindowActorParent" "\0"
  /*  7473 */ "KeyEvent" "\0"
  /*  7482 */ "KeyboardEvent" "\0"
  /*  7496 */ "KeyframeEffect" "\0"
  /*  7511 */ "L10nFileSource" "\0"
  /*  7526 */ "L10nOverlays" "\0"
  /*  7539 */ "L10nRegistry" "\0"
  /*  7552 */ "LargestContentfulPaint" "\0"
  /*  7575 */ "LegacyMozTCPSocket" "\0"
  /*  7594 */ "Localization" "\0"
  /*  7607 */ "Location" "\0"
  /*  7616 */ "Lock" "\0"
  /*  7621 */ "LockManager" "\0"
  /*  7633 */ "MIDIAccess" "\0"
  /*  7644 */ "MIDIConnectionEvent" "\0"
  /*  7664 */ "MIDIInput" "\0"
  /*  7674 */ "MIDIInputMap" "\0"
  /*  7687 */ "MIDIMessageEvent" "\0"
  /*  7704 */ "MIDIOutput" "\0"
  /*  7715 */ "MIDIOutputMap" "\0"
  /*  7729 */ "MIDIPort" "\0"
  /*  7738 */ "MOZ_debug" "\0"
  /*  7748 */ "MatchGlob" "\0"
  /*  7758 */ "MatchPattern" "\0"
  /*  7771 */ "MatchPatternSet" "\0"
  /*  7787 */ "MathMLElement" "\0"
  /*  7801 */ "MediaCapabilities" "\0"
  /*  7819 */ "MediaCapabilitiesInfo" "\0"
  /*  7841 */ "MediaControlService" "\0"
  /*  7861 */ "MediaController" "\0"
  /*  7877 */ "MediaDeviceInfo" "\0"
  /*  7893 */ "MediaDevices" "\0"
  /*  7906 */ "MediaElementAudioSourceNode" "\0"
  /*  7934 */ "MediaEncryptedEvent" "\0"
  /*  7954 */ "MediaError" "\0"
  /*  7965 */ "MediaKeyError" "\0"
  /*  7979 */ "MediaKeyMessageEvent" "\0"
  /*  8000 */ "MediaKeySession" "\0"
  /*  8016 */ "MediaKeyStatusMap" "\0"
  /*  8034 */ "MediaKeyStatusMap Iterator" "\0"
  /*  8061 */ "MediaKeySystemAccess" "\0"
  /*  8082 */ "MediaKeys" "\0"
  /*  8092 */ "MediaList" "\0"
  /*  8102 */ "MediaMetadata" "\0"
  /*  8116 */ "MediaQueryList" "\0"
  /*  8131 */ "MediaQueryListEvent" "\0"
  /*  8151 */ "MediaRecorder" "\0"
  /*  8165 */ "MediaRecorderErrorEvent" "\0"
  /*  8189 */ "MediaSession" "\0"
  /*  8202 */ "MediaSource" "\0"
  /*  8214 */ "MediaStream" "\0"
  /*  8226 */ "MediaStreamAudioDestinationNode" "\0"
  /*  8258 */ "MediaStreamAudioSourceNode" "\0"
  /*  8285 */ "MediaStreamError" "\0"
  /*  8302 */ "MediaStreamEvent" "\0"
  /*  8319 */ "MediaStreamTrack" "\0"
  /*  8336 */ "MediaStreamTrackAudioSourceNode" "\0"
  /*  8368 */ "MediaStreamTrackEvent" "\0"
  /*  8390 */ "MerchantValidationEvent" "\0"
  /*  8414 */ "MessageBroadcaster" "\0"
  /*  8433 */ "MessageChannel" "\0"
  /*  8448 */ "MessageEvent" "\0"
  /*  8461 */ "MessageListenerManager" "\0"
  /*  8484 */ "MessagePort" "\0"
  /*  8496 */ "MessageSender" "\0"
  /*  8510 */ "MimeType" "\0"
  /*  8519 */ "MimeTypeArray" "\0"
  /*  8533 */ "MouseEvent" "\0"
  /*  8544 */ "MouseScrollEvent" "\0"
  /*  8561 */ "MozCanvasPrintState" "\0"
  /*  8581 */ "MozDocumentMatcher" "\0"
  /*  8600 */ "MozDocumentObserver" "\0"
  /*  8620 */ "MozQueryInterface" "\0"
  /*  8638 */ "MozSharedMap" "\0"
  /*  8651 */ "MozSharedMap Iterator" "\0"
  /*  8673 */ "MozSharedMapChangeEvent" "\0"
  /*  8697 */ "MozStorageAsyncStatementParams" "\0"
  /*  8728 */ "MozStorageStatementParams" "\0"
  /*  8754 */ "MozStorageStatementRow" "\0"
  /*  8777 */ "MozWritableSharedMap" "\0"
  /*  8798 */ "MutationEvent" "\0"
  /*  8812 */ "MutationObserver" "\0"
  /*  8829 */ "MutationRecord" "\0"
  /*  8844 */ "NamedNodeMap" "\0"
  /*  8857 */ "NavigationPreloadManager" "\0"
  /*  8882 */ "Navigator" "\0"
  /*  8892 */ "NetworkInformation" "\0"
  /*  8911 */ "Node" "\0"
  /*  8916 */ "NodeFilter" "\0"
  /*  8927 */ "NodeIterator" "\0"
  /*  8940 */ "NodeList" "\0"
  /*  8949 */ "Notification" "\0"
  /*  8962 */ "NotificationEvent" "\0"
  /*  8980 */ "NotifyPaintEvent" "\0"
  /*  8997 */ "OES_draw_buffers_indexed" "\0"
  /*  9022 */ "OES_element_index_uint" "\0"
  /*  9045 */ "OES_fbo_render_mipmap" "\0"
  /*  9067 */ "OES_standard_derivatives" "\0"
  /*  9092 */ "OES_texture_float" "\0"
  /*  9110 */ "OES_texture_float_linear" "\0"
  /*  9135 */ "OES_texture_half_float" "\0"
  /*  9158 */ "OES_texture_half_float_linear" "\0"
  /*  9188 */ "OES_vertex_array_object" "\0"
  /*  9212 */ "OVR_multiview2" "\0"
  /*  9227 */ "OfflineAudioCompletionEvent" "\0"
  /*  9255 */ "OfflineAudioContext" "\0"
  /*  9275 */ "OffscreenCanvas" "\0"
  /*  9291 */ "OffscreenCanvasRenderingContext2D" "\0"
  /*  9325 */ "OnlyForUseInConstructor" "\0"
  /*  9349 */ "Option" "\0"
  /*  9356 */ "OscillatorNode" "\0"
  /*  9371 */ "PageTransitionEvent" "\0"
  /*  9391 */ "PaintRequest" "\0"
  /*  9404 */ "PaintRequestList" "\0"
  /*  9421 */ "PaintWorkletGlobalScope" "\0"
  /*  9445 */ "PannerNode" "\0"
  /*  9456 */ "ParentProcessMessageManager" "\0"
  /*  9484 */ "Path2D" "\0"
  /*  9491 */ "PathUtils" "\0"
  /*  9501 */ "PaymentAddress" "\0"
  /*  9516 */ "PaymentMethodChangeEvent" "\0"
  /*  9541 */ "PaymentRequest" "\0"
  /*  9556 */ "PaymentRequestUpdateEvent" "\0"
  /*  9582 */ "PaymentResponse" "\0"
  /*  9598 */ "PeerConnectionImpl" "\0"
  /*  9617 */ "PeerConnectionObserver" "\0"
  /*  9640 */ "Performance" "\0"
  /*  9652 */ "PerformanceEntry" "\0"
  /*  9669 */ "PerformanceEntryEvent" "\0"
  /*  9691 */ "PerformanceEventTiming" "\0"
  /*  9714 */ "PerformanceMark" "\0"
  /*  9730 */ "PerformanceMeasure" "\0"
  /*  9749 */ "PerformanceNavigation" "\0"
  /*  9771 */ "PerformanceNavigationTiming" "\0"
  /*  9799 */ "PerformanceObserver" "\0"
  /*  9819 */ "PerformanceObserverEntryList" "\0"
  /*  9848 */ "PerformancePaintTiming" "\0"
  /*  9871 */ "PerformanceResourceTiming" "\0"
  /*  9897 */ "PerformanceServerTiming" "\0"
  /*  9921 */ "PerformanceTiming" "\0"
  /*  9939 */ "PeriodicWave" "\0"
  /*  9952 */ "PermissionStatus" "\0"
  /*  9969 */ "Permissions" "\0"
  /*  9981 */ "PlacesBookmark" "\0"
  /*  9996 */ "PlacesBookmarkAddition" "\0"
  /* 10019 */ "PlacesBookmarkChanged" "\0"
  /* 10041 */ "PlacesBookmarkGuid" "\0"
  /* 10060 */ "PlacesBookmarkKeyword" "\0"
  /* 10082 */ "PlacesBookmarkMoved" "\0"
  /* 10102 */ "PlacesBookmarkRemoved" "\0"
  /* 10124 */ "PlacesBookmarkTags" "\0"
  /* 10143 */ "PlacesBookmarkTime" "\0"
  /* 10162 */ "PlacesBookmarkTitle" "\0"
  /* 10182 */ "PlacesBookmarkUrl" "\0"
  /* 10200 */ "PlacesEvent" "\0"
  /* 10212 */ "PlacesEventCounts" "\0"
  /* 10230 */ "PlacesFavicon" "\0"
  /* 10244 */ "PlacesHistoryCleared" "\0"
  /* 10265 */ "PlacesObservers" "\0"
  /* 10281 */ "PlacesPurgeCaches" "\0"
  /* 10299 */ "PlacesRanking" "\0"
  /* 10313 */ "PlacesVisit" "\0"
  /* 10325 */ "PlacesVisitRemoved" "\0"
  /* 10344 */ "PlacesVisitTitle" "\0"
  /* 10361 */ "PlacesWeakCallbackWrapper" "\0"
  /* 10387 */ "Plugin" "\0"
  /* 10394 */ "PluginArray" "\0"
  /* 10406 */ "PluginCrashedEvent" "\0"
  /* 10425 */ "PointerEvent" "\0"
  /* 10438 */ "PopStateEvent" "\0"
  /* 10452 */ "PopupBlockedEvent" "\0"
  /* 10470 */ "PopupPositionedEvent" "\0"
  /* 10491 */ "PositionStateEvent" "\0"
  /* 10510 */ "PrecompiledScript" "\0"
  /* 10528 */ "ProcessMessageManager" "\0"
  /* 10550 */ "ProcessingInstruction" "\0"
  /* 10572 */ "ProgressEvent" "\0"
  /* 10586 */ "PromiseDebugging" "\0"
  /* 10603 */ "PromiseNativeHandler" "\0"
  /* 10624 */ "PromiseRejectionEvent" "\0"
  /* 10646 */ "PublicKeyCredential" "\0"
  /* 10666 */ "PushEvent" "\0"
  /* 10676 */ "PushManager" "\0"
  /* 10688 */ "PushManagerImpl" "\0"
  /* 10704 */ "PushMessageData" "\0"
  /* 10720 */ "PushSubscription" "\0"
  /* 10737 */ "PushSubscriptionOptions" "\0"
  /* 10761 */ "RTCCertificate" "\0"
  /* 10776 */ "RTCDTMFSender" "\0"
  /* 10790 */ "RTCDTMFToneChangeEvent" "\0"
  /* 10813 */ "RTCDataChannel" "\0"
  /* 10828 */ "RTCDataChannelEvent" "\0"
  /* 10848 */ "RTCDtlsTransport" "\0"
  /* 10865 */ "RTCEncodedAudioFrame" "\0"
  /* 10886 */ "RTCEncodedVideoFrame" "\0"
  /* 10907 */ "RTCIceCandidate" "\0"
  /* 10923 */ "RTCIceTransport" "\0"
  /* 10939 */ "RTCIdentityProviderRegistrar" "\0"
  /* 10968 */ "RTCPeerConnection" "\0"
  /* 10986 */ "RTCPeerConnectionIceEvent" "\0"
  /* 11012 */ "RTCPeerConnectionStatic" "\0"
  /* 11036 */ "RTCRtpReceiver" "\0"
  /* 11051 */ "RTCRtpScriptTransform" "\0"
  /* 11073 */ "RTCRtpScriptTransformer" "\0"
  /* 11097 */ "RTCRtpSender" "\0"
  /* 11110 */ "RTCRtpTransceiver" "\0"
  /* 11128 */ "RTCSctpTransport" "\0"
  /* 11145 */ "RTCSessionDescription" "\0"
  /* 11167 */ "RTCStatsReport" "\0"
  /* 11182 */ "RTCTrackEvent" "\0"
  /* 11196 */ "RTCTransformEvent" "\0"
  /* 11214 */ "RadioNodeList" "\0"
  /* 11228 */ "Range" "\0"
  /* 11234 */ "ReadableByteStreamController" "\0"
  /* 11263 */ "ReadableStream" "\0"
  /* 11278 */ "ReadableStream AsyncIterator" "\0"
  /* 11307 */ "ReadableStreamBYOBReader" "\0"
  /* 11332 */ "ReadableStreamBYOBRequest" "\0"
  /* 11358 */ "ReadableStreamDefaultController" "\0"
  /* 11390 */ "ReadableStreamDefaultReader" "\0"
  /* 11418 */ "Report" "\0"
  /* 11425 */ "ReportBody" "\0"
  /* 11436 */ "ReportingObserver" "\0"
  /* 11454 */ "Request" "\0"
  /* 11462 */ "ResizeObserver" "\0"
  /* 11477 */ "ResizeObserverEntry" "\0"
  /* 11497 */ "ResizeObserverSize" "\0"
  /* 11516 */ "Response" "\0"
  /* 11525 */ "SVGAElement" "\0"
  /* 11537 */ "SVGAngle" "\0"
  /* 11546 */ "SVGAnimateElement" "\0"
  /* 11564 */ "SVGAnimateMotionElement" "\0"
  /* 11588 */ "SVGAnimateTransformElement" "\0"
  /* 11615 */ "SVGAnimatedAngle" "\0"
  /* 11632 */ "SVGAnimatedBoolean" "\0"
  /* 11651 */ "SVGAnimatedEnumeration" "\0"
  /* 11674 */ "SVGAnimatedInteger" "\0"
  /* 11693 */ "SVGAnimatedLength" "\0"
  /* 11711 */ "SVGAnimatedLengthList" "\0"
  /* 11733 */ "SVGAnimatedNumber" "\0"
  /* 11751 */ "SVGAnimatedNumberList" "\0"
  /* 11773 */ "SVGAnimatedPreserveAspectRatio" "\0"
  /* 11804 */ "SVGAnimatedRect" "\0"
  /* 11820 */ "SVGAnimatedString" "\0"
  /* 11838 */ "SVGAnimatedTransformList" "\0"
  /* 11863 */ "SVGAnimationElement" "\0"
  /* 11883 */ "SVGCircleElement" "\0"
  /* 11900 */ "SVGClipPathElement" "\0"
  /* 11919 */ "SVGComponentTransferFunctionElement" "\0"
  /* 11955 */ "SVGDefsElement" "\0"
  /* 11970 */ "SVGDescElement" "\0"
  /* 11985 */ "SVGElement" "\0"
  /* 11996 */ "SVGEllipseElement" "\0"
  /* 12014 */ "SVGFEBlendElement" "\0"
  /* 12032 */ "SVGFEColorMatrixElement" "\0"
  /* 12056 */ "SVGFEComponentTransferElement" "\0"
  /* 12086 */ "SVGFECompositeElement" "\0"
  /* 12108 */ "SVGFEConvolveMatrixElement" "\0"
  /* 12135 */ "SVGFEDiffuseLightingElement" "\0"
  /* 12163 */ "SVGFEDisplacementMapElement" "\0"
  /* 12191 */ "SVGFEDistantLightElement" "\0"
  /* 12216 */ "SVGFEDropShadowElement" "\0"
  /* 12239 */ "SVGFEFloodElement" "\0"
  /* 12257 */ "SVGFEFuncAElement" "\0"
  /* 12275 */ "SVGFEFuncBElement" "\0"
  /* 12293 */ "SVGFEFuncGElement" "\0"
  /* 12311 */ "SVGFEFuncRElement" "\0"
  /* 12329 */ "SVGFEGaussianBlurElement" "\0"
  /* 12354 */ "SVGFEImageElement" "\0"
  /* 12372 */ "SVGFEMergeElement" "\0"
  /* 12390 */ "SVGFEMergeNodeElement" "\0"
  /* 12412 */ "SVGFEMorphologyElement" "\0"
  /* 12435 */ "SVGFEOffsetElement" "\0"
  /* 12454 */ "SVGFEPointLightElement" "\0"
  /* 12477 */ "SVGFESpecularLightingElement" "\0"
  /* 12506 */ "SVGFESpotLightElement" "\0"
  /* 12528 */ "SVGFETileElement" "\0"
  /* 12545 */ "SVGFETurbulenceElement" "\0"
  /* 12568 */ "SVGFilterElement" "\0"
  /* 12585 */ "SVGForeignObjectElement" "\0"
  /* 12609 */ "SVGGElement" "\0"
  /* 12621 */ "SVGGeometryElement" "\0"
  /* 12640 */ "SVGGradientElement" "\0"
  /* 12659 */ "SVGGraphicsElement" "\0"
  /* 12678 */ "SVGImageElement" "\0"
  /* 12694 */ "SVGLength" "\0"
  /* 12704 */ "SVGLengthList" "\0"
  /* 12718 */ "SVGLineElement" "\0"
  /* 12733 */ "SVGLinearGradientElement" "\0"
  /* 12758 */ "SVGMPathElement" "\0"
  /* 12774 */ "SVGMarkerElement" "\0"
  /* 12791 */ "SVGMaskElement" "\0"
  /* 12806 */ "SVGMatrix" "\0"
  /* 12816 */ "SVGMetadataElement" "\0"
  /* 12835 */ "SVGNumber" "\0"
  /* 12845 */ "SVGNumberList" "\0"
  /* 12859 */ "SVGPathElement" "\0"
  /* 12874 */ "SVGPathSeg" "\0"
  /* 12885 */ "SVGPathSegArcAbs" "\0"
  /* 12902 */ "SVGPathSegArcRel" "\0"
  /* 12919 */ "SVGPathSegClosePath" "\0"
  /* 12939 */ "SVGPathSegCurvetoCubicAbs" "\0"
  /* 12965 */ "SVGPathSegCurvetoCubicRel" "\0"
  /* 12991 */ "SVGPathSegCurvetoCubicSmoothAbs" "\0"
  /* 13023 */ "SVGPathSegCurvetoCubicSmoothRel" "\0"
  /* 13055 */ "SVGPathSegCurvetoQuadraticAbs" "\0"
  /* 13085 */ "SVGPathSegCurvetoQuadraticRel" "\0"
  /* 13115 */ "SVGPathSegCurvetoQuadraticSmoothAbs" "\0"
  /* 13151 */ "SVGPathSegCurvetoQuadraticSmoothRel" "\0"
  /* 13187 */ "SVGPathSegLinetoAbs" "\0"
  /* 13207 */ "SVGPathSegLinetoHorizontalAbs" "\0"
  /* 13237 */ "SVGPathSegLinetoHorizontalRel" "\0"
  /* 13267 */ "SVGPathSegLinetoRel" "\0"
  /* 13287 */ "SVGPathSegLinetoVerticalAbs" "\0"
  /* 13315 */ "SVGPathSegLinetoVerticalRel" "\0"
  /* 13343 */ "SVGPathSegList" "\0"
  /* 13358 */ "SVGPathSegMovetoAbs" "\0"
  /* 13378 */ "SVGPathSegMovetoRel" "\0"
  /* 13398 */ "SVGPatternElement" "\0"
  /* 13416 */ "SVGPoint" "\0"
  /* 13425 */ "SVGPointList" "\0"
  /* 13438 */ "SVGPolygonElement" "\0"
  /* 13456 */ "SVGPolylineElement" "\0"
  /* 13475 */ "SVGPreserveAspectRatio" "\0"
  /* 13498 */ "SVGRadialGradientElement" "\0"
  /* 13523 */ "SVGRect" "\0"
  /* 13531 */ "SVGRectElement" "\0"
  /* 13546 */ "SVGSVGElement" "\0"
  /* 13560 */ "SVGScriptElement" "\0"
  /* 13577 */ "SVGSetElement" "\0"
  /* 13591 */ "SVGStopElement" "\0"
  /* 13606 */ "SVGStringList" "\0"
  /* 13620 */ "SVGStyleElement" "\0"
  /* 13636 */ "SVGSwitchElement" "\0"
  /* 13653 */ "SVGSymbolElement" "\0"
  /* 13670 */ "SVGTSpanElement" "\0"
  /* 13686 */ "SVGTextContentElement" "\0"
  /* 13708 */ "SVGTextElement" "\0"
  /* 13723 */ "SVGTextPathElement" "\0"
  /* 13742 */ "SVGTextPositioningElement" "\0"
  /* 13768 */ "SVGTitleElement" "\0"
  /* 13784 */ "SVGTransform" "\0"
  /* 13797 */ "SVGTransformList" "\0"
  /* 13814 */ "SVGUnitTypes" "\0"
  /* 13827 */ "SVGUseElement" "\0"
  /* 13841 */ "SVGViewElement" "\0"
  /* 13856 */ "Sanitizer" "\0"
  /* 13866 */ "Scheduler" "\0"
  /* 13876 */ "Screen" "\0"
  /* 13883 */ "ScreenLuminance" "\0"
  /* 13899 */ "ScreenOrientation" "\0"
  /* 13917 */ "ScriptProcessorNode" "\0"
  /* 13937 */ "ScrollAreaEvent" "\0"
  /* 13953 */ "ScrollViewChangeEvent" "\0"
  /* 13975 */ "SecurityPolicyViolationEvent" "\0"
  /* 14004 */ "Selection" "\0"
  /* 14014 */ "ServiceWorker" "\0"
  /* 14028 */ "ServiceWorkerContainer" "\0"
  /* 14051 */ "ServiceWorkerGlobalScope" "\0"
  /* 14076 */ "ServiceWorkerRegistration" "\0"
  /* 14102 */ "SessionStoreFormData" "\0"
  /* 14123 */ "SessionStoreScrollData" "\0"
  /* 14146 */ "SessionStoreUtils" "\0"
  /* 14164 */ "ShadowRealmGlobalScope" "\0"
  /* 14187 */ "ShadowRoot" "\0"
  /* 14198 */ "SharedWorker" "\0"
  /* 14211 */ "SharedWorkerGlobalScope" "\0"
  /* 14235 */ "SimpleGestureEvent" "\0"
  /* 14254 */ "SourceBuffer" "\0"
  /* 14267 */ "SourceBufferList" "\0"
  /* 14284 */ "SpeechGrammar" "\0"
  /* 14298 */ "SpeechGrammarList" "\0"
  /* 14316 */ "SpeechRecognition" "\0"
  /* 14334 */ "SpeechRecognitionAlternative" "\0"
  /* 14363 */ "SpeechRecognitionError" "\0"
  /* 14386 */ "SpeechRecognitionEvent" "\0"
  /* 14409 */ "SpeechRecognitionResult" "\0"
  /* 14433 */ "SpeechRecognitionResultList" "\0"
  /* 14461 */ "SpeechSynthesis" "\0"
  /* 14477 */ "SpeechSynthesisErrorEvent" "\0"
  /* 14503 */ "SpeechSynthesisEvent" "\0"
  /* 14524 */ "SpeechSynthesisUtterance" "\0"
  /* 14549 */ "SpeechSynthesisVoice" "\0"
  /* 14570 */ "StaticRange" "\0"
  /* 14582 */ "StereoPannerNode" "\0"
  /* 14599 */ "Storage" "\0"
  /* 14607 */ "StorageEvent" "\0"
  /* 14620 */ "StorageManager" "\0"
  /* 14635 */ "StreamFilter" "\0"
  /* 14648 */ "StreamFilterDataEvent" "\0"
  /* 14670 */ "StructuredCloneHolder" "\0"
  /* 14692 */ "StructuredCloneTester" "\0"
  /* 14714 */ "StyleSheet" "\0"
  /* 14725 */ "StyleSheetApplicableStateChangeEvent" "\0"
  /* 14762 */ "StyleSheetList" "\0"
  /* 14777 */ "StyleSheetRemovedEvent" "\0"
  /* 14800 */ "SubmitEvent" "\0"
  /* 14812 */ "SubtleCrypto" "\0"
  /* 14825 */ "SyncMessageSender" "\0"
  /* 14843 */ "SyncReadFile" "\0"
  /* 14856 */ "TCPServerSocket" "\0"
  /* 14872 */ "TCPServerSocketEvent" "\0"
  /* 14893 */ "TCPSocket" "\0"
  /* 14903 */ "TCPSocketErrorEvent" "\0"
  /* 14923 */ "TCPSocketEvent" "\0"
  /* 14938 */ "TaskController" "\0"
  /* 14953 */ "TaskPriorityChangeEvent" "\0"
  /* 14977 */ "TaskSignal" "\0"
  /* 14988 */ "TelemetryStopwatch" "\0"
  /* 15007 */ "TestAttributesOnTypes" "\0"
  /* 15029 */ "TestCEReactionsInterface" "\0"
  /* 15054 */ "TestCImplementedInterface" "\0"
  /* 15080 */ "TestCImplementedInterface2" "\0"
  /* 15107 */ "TestCallbackDictUnionOverload" "\0"
  /* 15137 */ "TestChildInterface" "\0"
  /* 15156 */ "TestConstructorForFuncInterface" "\0"
  /* 15188 */ "TestConstructorForPrefInterface" "\0"
  /* 15220 */ "TestConstructorForSCInterface" "\0"
  /* 15250 */ "TestCppKeywordNamedMethodsInterface" "\0"
  /* 15286 */ "TestDeprecatedInterface" "\0"
  /* 15310 */ "TestExampleInterface" "\0"
  /* 15331 */ "TestExampleProxyInterface" "\0"
  /* 15357 */ "TestExampleThrowingConstructorInterface" "\0"
  /* 15397 */ "TestExampleWorkerInterface" "\0"
  /* 15424 */ "TestFuncConstructorForDifferentFuncInterface" "\0"
  /* 15469 */ "TestFuncConstructorForInterface" "\0"
  /* 15501 */ "TestHTMLConstructorInterface" "\0"
  /* 15530 */ "TestIndexedAndNamedGetterAndSetterInterface" "\0"
  /* 15574 */ "TestIndexedAndNamedGetterInterface" "\0"
  /* 15609 */ "TestIndexedAndNamedSetterInterface" "\0"
  /* 15644 */ "TestIndexedGetterAndSetterAndNamedGetterInterface" "\0"
  /* 15694 */ "TestIndexedGetterInterface" "\0"
  /* 15721 */ "TestIndexedSetterInterface" "\0"
  /* 15748 */ "TestInterface" "\0"
  /* 15762 */ "TestInterfaceWithPromiseConstructorArg" "\0"
  /* 15801 */ "TestJSImplInterface" "\0"
  /* 15821 */ "TestJSImplInterface2" "\0"
  /* 15842 */ "TestJSImplInterface3" "\0"
  /* 15863 */ "TestJSImplInterface4" "\0"
  /* 15884 */ "TestJSImplInterface5" "\0"
  /* 15905 */ "TestJSImplInterface6" "\0"
  /* 15926 */ "TestJSImplNoInterfaceObject" "\0"
  /* 15954 */ "TestLegacyFactoryFunctionInterface" "\0"
  /* 15989 */ "TestLegacyFactoryFunctionInterface2" "\0"
  /* 16025 */ "TestNamedDeleterInterface" "\0"
  /* 16051 */ "TestNamedDeleterWithRetvalInterface" "\0"
  /* 16087 */ "TestNamedGetterInterface" "\0"
  /* 16112 */ "TestNamedSetterInterface" "\0"
  /* 16137 */ "TestNamespace" "\0"
  /* 16151 */ "TestNonWrapperCacheInterface" "\0"
  /* 16180 */ "TestParentInterface" "\0"
  /* 16200 */ "TestPrefChromeOnlySCFuncConstructorForInterface" "\0"
  /* 16248 */ "TestPrefConstructorForDifferentPrefInterface" "\0"
  /* 16293 */ "TestPrefConstructorForInterface" "\0"
  /* 16325 */ "TestProtoObjectHackedNamespace" "\0"
  /* 16356 */ "TestRenamedInterface" "\0"
  /* 16377 */ "TestRenamedNamespace" "\0"
  /* 16398 */ "TestSCConstructorForInterface" "\0"
  /* 16428 */ "TestSecureContextInterface" "\0"
  /* 16455 */ "TestThrowingConstructorInterface" "\0"
  /* 16488 */ "TestUtils" "\0"
  /* 16498 */ "TestWorkerExposedInterface" "\0"
  /* 16525 */ "TestingDeprecatedInterface" "\0"
  /* 16552 */ "Text" "\0"
  /* 16557 */ "TextClause" "\0"
  /* 16568 */ "TextDecoder" "\0"
  /* 16580 */ "TextDecoderStream" "\0"
  /* 16598 */ "TextEncoder" "\0"
  /* 16610 */ "TextEncoderStream" "\0"
  /* 16628 */ "TextEvent" "\0"
  /* 16638 */ "TextMetrics" "\0"
  /* 16650 */ "TextTrack" "\0"
  /* 16660 */ "TextTrackCue" "\0"
  /* 16673 */ "TextTrackCueList" "\0"
  /* 16690 */ "TextTrackList" "\0"
  /* 16704 */ "TimeEvent" "\0"
  /* 16714 */ "TimeRanges" "\0"
  /* 16725 */ "ToggleEvent" "\0"
  /* 16737 */ "Touch" "\0"
  /* 16743 */ "TouchEvent" "\0"
  /* 16754 */ "TouchList" "\0"
  /* 16764 */ "TrackEvent" "\0"
  /* 16775 */ "TransformStream" "\0"
  /* 16791 */ "TransformStreamDefaultController" "\0"
  /* 16824 */ "TransitionEvent" "\0"
  /* 16840 */ "TreeColumn" "\0"
  /* 16851 */ "TreeColumns" "\0"
  /* 16863 */ "TreeContentView" "\0"
  /* 16879 */ "TreeWalker" "\0"
  /* 16890 */ "TrustedHTML" "\0"
  /* 16902 */ "TrustedScript" "\0"
  /* 16916 */ "TrustedScriptURL" "\0"
  /* 16933 */ "TrustedTypePolicy" "\0"
  /* 16951 */ "TrustedTypePolicyFactory" "\0"
  /* 16976 */ "UDPMessageEvent" "\0"
  /* 16992 */ "UDPSocket" "\0"
  /* 17002 */ "UIEvent" "\0"
  /* 17010 */ "URL" "\0"
  /* 17014 */ "URLSearchParams" "\0"
  /* 17030 */ "URLSearchParams Iterator" "\0"
  /* 17055 */ "UniFFIPointer" "\0"
  /* 17069 */ "UniFFIScaffolding" "\0"
  /* 17087 */ "UserActivation" "\0"
  /* 17102 */ "UserInteraction" "\0"
  /* 17118 */ "UserProximityEvent" "\0"
  /* 17137 */ "VRDisplay" "\0"
  /* 17147 */ "VRDisplayCapabilities" "\0"
  /* 17169 */ "VRDisplayEvent" "\0"
  /* 17184 */ "VREyeParameters" "\0"
  /* 17200 */ "VRFieldOfView" "\0"
  /* 17214 */ "VRFrameData" "\0"
  /* 17226 */ "VRMockController" "\0"
  /* 17243 */ "VRMockDisplay" "\0"
  /* 17257 */ "VRPose" "\0"
  /* 17264 */ "VRServiceTest" "\0"
  /* 17278 */ "VRStageParameters" "\0"
  /* 17296 */ "VTTCue" "\0"
  /* 17303 */ "VTTRegion" "\0"
  /* 17313 */ "ValidityState" "\0"
  /* 17327 */ "VideoColorSpace" "\0"
  /* 17343 */ "VideoDecoder" "\0"
  /* 17356 */ "VideoEncoder" "\0"
  /* 17369 */ "VideoFrame" "\0"
  /* 17380 */ "VideoPlaybackQuality" "\0"
  /* 17401 */ "VideoTrack" "\0"
  /* 17412 */ "VideoTrackList" "\0"
  /* 17427 */ "VisualViewport" "\0"
  /* 17442 */ "WEBGL_color_buffer_float" "\0"
  /* 17467 */ "WEBGL_compressed_texture_astc" "\0"
  /* 17497 */ "WEBGL_compressed_texture_etc" "\0"
  /* 17526 */ "WEBGL_compressed_texture_etc1" "\0"
  /* 17556 */ "WEBGL_compressed_texture_pvrtc" "\0"
  /* 17587 */ "WEBGL_compressed_texture_s3tc" "\0"
  /* 17617 */ "WEBGL_compressed_texture_s3tc_srgb" "\0"
  /* 17652 */ "WEBGL_debug_renderer_info" "\0"
  /* 17678 */ "WEBGL_debug_shaders" "\0"
  /* 17698 */ "WEBGL_depth_texture" "\0"
  /* 17718 */ "WEBGL_draw_buffers" "\0"
  /* 17737 */ "WEBGL_explicit_present" "\0"
  /* 17760 */ "WEBGL_lose_context" "\0"
  /* 17779 */ "WEBGL_provoking_vertex" "\0"
  /* 17802 */ "WakeLock" "\0"
  /* 17811 */ "WakeLockSentinel" "\0"
  /* 17828 */ "WaveShaperNode" "\0"
  /* 17843 */ "WebExtensionContentScript" "\0"
  /* 17869 */ "WebExtensionPolicy" "\0"
  /* 17888 */ "WebGL2RenderingContext" "\0"
  /* 17911 */ "WebGLActiveInfo" "\0"
  /* 17927 */ "WebGLBuffer" "\0"
  /* 17939 */ "WebGLContextEvent" "\0"
  /* 17957 */ "WebGLFramebuffer" "\0"
  /* 17974 */ "WebGLProgram" "\0"
  /* 17987 */ "WebGLQuery" "\0"
  /* 17998 */ "WebGLRenderbuffer" "\0"
  /* 18016 */ "WebGLRenderingContext" "\0"
  /* 18038 */ "WebGLSampler" "\0"
  /* 18051 */ "WebGLShader" "\0"
  /* 18063 */ "WebGLShaderPrecisionFormat" "\0"
  /* 18090 */ "WebGLSync" "\0"
  /* 18100 */ "WebGLTexture" "\0"
  /* 18113 */ "WebGLTransformFeedback" "\0"
  /* 18136 */ "WebGLUniformLocation" "\0"
  /* 18157 */ "WebGLVertexArrayObject" "\0"
  /* 18180 */ "WebKitCSSMatrix" "\0"
  /* 18196 */ "WebSocket" "\0"
  /* 18206 */ "WebTransport" "\0"
  /* 18219 */ "WebTransportBidirectionalStream" "\0"
  /* 18251 */ "WebTransportDatagramDuplexStream" "\0"
  /* 18284 */ "WebTransportError" "\0"
  /* 18302 */ "WebTransportReceiveStream" "\0"
  /* 18328 */ "WebTransportSendStream" "\0"
  /* 18351 */ "WebrtcGlobalInformation" "\0"
  /* 18375 */ "WheelEvent" "\0"
  /* 18386 */ "Window" "\0"
  /* 18393 */ "WindowClient" "\0"
  /* 18406 */ "WindowContext" "\0"
  /* 18420 */ "WindowGlobalChild" "\0"
  /* 18438 */ "WindowGlobalParent" "\0"
  /* 18457 */ "WindowRoot" "\0"
  /* 18468 */ "Worker" "\0"
  /* 18475 */ "WorkerDebuggerGlobalScope" "\0"
  /* 18501 */ "WorkerGlobalScope" "\0"
  /* 18519 */ "WorkerLocation" "\0"
  /* 18534 */ "WorkerNavigator" "\0"
  /* 18550 */ "WorkerTestUtils" "\0"
  /* 18566 */ "Worklet" "\0"
  /* 18574 */ "WorkletGlobalScope" "\0"
  /* 18593 */ "WritableStream" "\0"
  /* 18608 */ "WritableStreamDefaultController" "\0"
  /* 18640 */ "WritableStreamDefaultWriter" "\0"
  /* 18668 */ "XMLDocument" "\0"
  /* 18680 */ "XMLHttpRequest" "\0"
  /* 18695 */ "XMLHttpRequestEventTarget" "\0"
  /* 18721 */ "XMLHttpRequestUpload" "\0"
  /* 18742 */ "XMLSerializer" "\0"
  /* 18756 */ "XPathEvaluator" "\0"
  /* 18771 */ "XPathExpression" "\0"
  /* 18787 */ "XPathResult" "\0"
  /* 18799 */ "XRBoundedReferenceSpace" "\0"
  /* 18823 */ "XRFrame" "\0"
  /* 18831 */ "XRInputSource" "\0"
  /* 18845 */ "XRInputSourceArray" "\0"
  /* 18864 */ "XRInputSourceEvent" "\0"
  /* 18883 */ "XRInputSourcesChangeEvent" "\0"
  /* 18909 */ "XRPose" "\0"
  /* 18916 */ "XRReferenceSpace" "\0"
  /* 18933 */ "XRReferenceSpaceEvent" "\0"
  /* 18955 */ "XRRenderState" "\0"
  /* 18969 */ "XRRigidTransform" "\0"
  /* 18986 */ "XRSession" "\0"
  /* 18996 */ "XRSessionEvent" "\0"
  /* 19011 */ "XRSpace" "\0"
  /* 19019 */ "XRSystem" "\0"
  /* 19028 */ "XRView" "\0"
  /* 19035 */ "XRViewerPose" "\0"
  /* 19048 */ "XRViewport" "\0"
  /* 19059 */ "XRWebGLLayer" "\0"
  /* 19072 */ "XSLTProcessor" "\0"
  /* 19086 */ "XULCommandEvent" "\0"
  /* 19102 */ "XULElement" "\0"
  /* 19113 */ "XULFrameElement" "\0"
  /* 19129 */ "XULMenuElement" "\0"
  /* 19144 */ "XULPopupElement" "\0"
  /* 19160 */ "XULResizerElement" "\0"
  /* 19178 */ "XULTextElement" "\0"
  /* 19193 */ "XULTreeElement" "\0"
  /* 19208 */ "console" "\0"
  /* 19216 */ "webkitSpeechGrammar" "\0"
  /* 19236 */ "webkitSpeechGrammarList" "\0"
  /* 19260 */ "webkitSpeechRecognition" "\0"
  /* 19284 */ "webkitURL"
};

}  // namespace binding_detail

// Making this enum bigger than a uint16_t has consequences on the size
// of some structs (eg. WebIDLNameTableEntry) and tables. We should try
// to avoid that.
static_assert(EnumTypeFitsWithin<BindingNamesOffset, uint16_t>::value,
              "Size increase");

} // namespace mozilla::dom

