#include "AbortControllerBinding.h"
#include "AbortSignalBinding.h"
#include "CompressionStreamBinding.h"
#include "ConsoleBinding.h"
#include "ConsoleInstanceBinding.h"
#include "DecompressionStreamBinding.h"
#include "EventTargetBinding.h"
#include "QueuingStrategyBinding.h"
#include "ReadableByteStreamControllerBinding.h"
#include "ReadableStreamBYOBReaderBinding.h"
#include "ReadableStreamBYOBRequestBinding.h"
#include "ReadableStreamBinding.h"
#include "ReadableStreamDefaultControllerBinding.h"
#include "ReadableStreamDefaultReaderBinding.h"
#include "StructuredCloneHolderBinding.h"
#include "TextDecoderStreamBinding.h"
#include "TextEncoderStreamBinding.h"
#include "TransformStreamBinding.h"
#include "TransformStreamDefaultControllerBinding.h"
#include "URLBinding.h"
#include "URLSearchParamsBinding.h"
#include "WorkerDebuggerGlobalScopeBinding.h"
#include "WritableStreamBinding.h"
#include "WritableStreamDefaultControllerBinding.h"
#include "WritableStreamDefaultWriterBinding.h"

namespace mozilla::dom {
bool
RegisterWorkerDebuggerBindings(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  if (!AbortController_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!AbortSignal_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!ByteLengthQueuingStrategy_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (CompressionStream_Binding::ConstructorEnabled(aCx, aObj) && !CompressionStream_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ConsoleInstance_Binding::ConstructorEnabled(aCx, aObj) && !ConsoleInstance_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!CountQueuingStrategy_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (DecompressionStream_Binding::ConstructorEnabled(aCx, aObj) && !DecompressionStream_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!EventTarget_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!ReadableByteStreamController_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!ReadableStream_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!ReadableStreamBYOBReader_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!ReadableStreamBYOBRequest_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!ReadableStreamDefaultController_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!ReadableStreamDefaultReader_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (StructuredCloneHolder_Binding::ConstructorEnabled(aCx, aObj) && !StructuredCloneHolder_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!TextDecoderStream_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!TextEncoderStream_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!TransformStream_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!TransformStreamDefaultController_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!URL_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!URLSearchParams_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!WorkerDebuggerGlobalScope_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!WritableStream_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!WritableStreamDefaultController_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!WritableStreamDefaultWriter_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!console_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  return true;
}

} // namespace mozilla::dom

