//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/PEndpointForReportChild.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/dom/EndpointForReportChild.h"

#include "mozilla/ipc/PBackgroundChild.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace dom {


MOZ_IMPLICIT PEndpointForReportChild::PEndpointForReportChild() :
    mozilla::ipc::IProtocol(PEndpointForReportMsgStart, mozilla::ipc::ChildSide)
{
    MOZ_COUNT_CTOR(PEndpointForReportChild);
}

PEndpointForReportChild::~PEndpointForReportChild()
{
    MOZ_COUNT_DTOR(PEndpointForReportChild);
}

auto PEndpointForReportChild::ActorAlloc() -> void
{
}

auto PEndpointForReportChild::ActorDealloc() -> void
{
    if (Manager()) {
        Manager()->DeallocManagee(PEndpointForReportMsgStart, this);
    }
}

auto PEndpointForReportChild::OtherPid() const -> ::base::ProcessId
{
    ::base::ProcessId pid =
        ::mozilla::ipc::IProtocol::ToplevelProtocol()->OtherPidMaybeInvalid();
    MOZ_RELEASE_ASSERT(pid != ::base::kInvalidProcessId);
    return pid;
}

auto PEndpointForReportChild::Manager() const -> PBackgroundChild*
{
    return static_cast<PBackgroundChild*>(IProtocol::Manager());
}

auto PEndpointForReportChild::AllManagedActorsCount() const -> uint32_t
{
    uint32_t total = 0;
    return total;

}

auto PEndpointForReportChild::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PEndpointForReportChild::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PEndpointForReportChild::OnMessageReceived(const Message& msg__) -> PEndpointForReportChild::Result
{
    switch (msg__.type()) {
    case MANAGED_ENDPOINT_BOUND_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            return MsgProcessed;
        }
    case MANAGED_ENDPOINT_DROPPED_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            this->ActorDisconnected(ManagedEndpointDropped);
            return MsgProcessed;
        }
    case PEndpointForReport::Msg___delete____ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PEndpointForReport", mozilla::ipc::ChildSide)) {
                mozilla::ipc::LogMessageForProtocol(
                    "PEndpointForReportChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PEndpointForReport::Msg___delete__", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};

            auto maybe__endpointURL = IPC::ReadParam<nsCString>((&(reader__)));
            if (!maybe__endpointURL) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;

            }
            auto& endpointURL = *maybe__endpointURL;
            // Sentinel = 'endpointURL'
            if ((!(((&(reader__)))->ReadSentinel(454427733)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<EndpointForReportChild*>(this))->Recv__delete__(std::move(endpointURL));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }


            this->ActorDisconnected(Deletion);

            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PEndpointForReportChild::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PEndpointForReportChild::Result
{
    return MsgNotKnown;
}

auto PEndpointForReportChild::DoomSubtree() -> void
{
    SetDoomed();
}

auto PEndpointForReportChild::PeekManagedActor() -> IProtocol*
{
    return nullptr;
}



} // namespace dom
} // namespace mozilla
namespace IPC {
auto ParamTraits<::mozilla::dom::PEndpointForReportChild*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<::mozilla::dom::PEndpointForReportChild*>::Read(IPC::MessageReader* aReader) -> IPC::ReadResult<paramType>
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor = aReader->GetActor()
        ->ReadActor(aReader, true, "PEndpointForReport", PEndpointForReportMsgStart);
    if (actor.isSome()) {
        return static_cast<::mozilla::dom::PEndpointForReportChild*>(actor.ref());
    }
    return {};
}

} // namespace IPC
