//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/locks/PLockRequestChild.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/dom/locks/IPCUtils.h"
#include "mozilla/dom/locks/LockRequestChild.h"

#include "mozilla/dom/locks/PLockManagerChild.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace dom {
namespace locks {


MOZ_IMPLICIT PLockRequestChild::PLockRequestChild() :
    mozilla::ipc::IRefCountedProtocol(PLockRequestMsgStart, mozilla::ipc::ChildSide)
{
    MOZ_COUNT_CTOR(PLockRequestChild);
}

PLockRequestChild::~PLockRequestChild()
{
    MOZ_COUNT_DTOR(PLockRequestChild);
}

auto PLockRequestChild::ActorAlloc() -> void
{
    AddRef();
}

auto PLockRequestChild::ActorDealloc() -> void
{
    Release();
}

auto PLockRequestChild::OtherPid() const -> ::base::ProcessId
{
    ::base::ProcessId pid =
        ::mozilla::ipc::IProtocol::ToplevelProtocol()->OtherPidMaybeInvalid();
    MOZ_RELEASE_ASSERT(pid != ::base::kInvalidProcessId);
    return pid;
}

auto PLockRequestChild::Manager() const -> PLockManagerChild*
{
    return static_cast<PLockManagerChild*>(IProtocol::Manager());
}

auto PLockRequestChild::AllManagedActorsCount() const -> uint32_t
{
    uint32_t total = 0;
    return total;

}

auto PLockRequestChild::Send__delete__(
        PLockRequestChild* actor,
        const bool& aAborted) -> bool
{
    if (!actor || !actor->CanSend()) {
        NS_WARNING("Attempt to __delete__ missing or closed actor");
        return false;
    }
    UniquePtr<IPC::Message> msg__ = PLockRequest::Msg___delete__((actor)->Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            actor};

    IPC::WriteParam((&(writer__)), aAborted);
    // Sentinel = 'aAborted'
    ((&(writer__)))->WriteSentinel(228590371);



    if (mozilla::ipc::LoggingEnabledFor("PLockRequest", mozilla::ipc::ChildSide)) {
        mozilla::ipc::LogMessageForProtocol(
            "PLockRequestChild",
            actor->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PLockRequest::Msg___delete__", OTHER);

    bool sendok__ = (actor)->ChannelSend(std::move(msg__));

    actor->ActorDisconnected(Deletion);
    return sendok__;
}

auto PLockRequestChild::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PLockRequestChild::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PLockRequestChild::OnMessageReceived(const Message& msg__) -> PLockRequestChild::Result
{
    switch (msg__.type()) {
    case MANAGED_ENDPOINT_BOUND_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            return MsgProcessed;
        }
    case MANAGED_ENDPOINT_DROPPED_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            this->ActorDisconnected(ManagedEndpointDropped);
            return MsgProcessed;
        }
    case PLockRequest::Msg_Resolve__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PLockRequest", mozilla::ipc::ChildSide)) {
                mozilla::ipc::LogMessageForProtocol(
                    "PLockRequestChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PLockRequest::Msg_Resolve", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};

            auto maybe__aMode = IPC::ReadParam<LockMode>((&(reader__)));
            if (!maybe__aMode) {
                FatalError("Error deserializing 'LockMode'");
                return MsgValueError;

            }
            auto& aMode = *maybe__aMode;
            // Sentinel = 'aMode'
            if ((!(((&(reader__)))->ReadSentinel(93848039)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'LockMode'");
                return MsgValueError;
            }
            auto maybe__aIsAvailable = IPC::ReadParam<bool>((&(reader__)));
            if (!maybe__aIsAvailable) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;

            }
            auto& aIsAvailable = *maybe__aIsAvailable;
            // Sentinel = 'aIsAvailable'
            if ((!(((&(reader__)))->ReadSentinel(491914399)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'bool'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<LockRequestChild*>(this))->RecvResolve(std::move(aMode), std::move(aIsAvailable));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PLockRequest::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    case PLockRequest::Msg___delete____ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PLockRequest", mozilla::ipc::ChildSide)) {
                mozilla::ipc::LogMessageForProtocol(
                    "PLockRequestChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PLockRequest::Msg___delete__", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};

            auto maybe__aAborted = IPC::ReadParam<bool>((&(reader__)));
            if (!maybe__aAborted) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;

            }
            auto& aAborted = *maybe__aAborted;
            // Sentinel = 'aAborted'
            if ((!(((&(reader__)))->ReadSentinel(228590371)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'bool'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<LockRequestChild*>(this))->Recv__delete__(std::move(aAborted));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }


            this->ActorDisconnected(Deletion);

            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PLockRequestChild::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PLockRequestChild::Result
{
    return MsgNotKnown;
}

auto PLockRequestChild::DoomSubtree() -> void
{
    SetDoomed();
}

auto PLockRequestChild::PeekManagedActor() -> IProtocol*
{
    return nullptr;
}



} // namespace locks
} // namespace dom
} // namespace mozilla
namespace IPC {
auto ParamTraits<::mozilla::dom::locks::PLockRequestChild*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<::mozilla::dom::locks::PLockRequestChild*>::Read(IPC::MessageReader* aReader) -> IPC::ReadResult<paramType>
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor = aReader->GetActor()
        ->ReadActor(aReader, true, "PLockRequest", PLockRequestMsgStart);
    if (actor.isSome()) {
        return static_cast<::mozilla::dom::locks::PLockRequestChild*>(actor.ref());
    }
    return {};
}

} // namespace IPC
