//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PTransportProviderParent.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/net/IPCTransportProvider.h"

#include "mozilla/net/PNeckoParent.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace net {


auto PTransportProviderParent::Recv__delete__() -> mozilla::ipc::IPCResult
{
    return IPC_OK();
}

MOZ_IMPLICIT PTransportProviderParent::PTransportProviderParent() :
    mozilla::ipc::IProtocol(PTransportProviderMsgStart, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PTransportProviderParent);
}

PTransportProviderParent::~PTransportProviderParent()
{
    MOZ_COUNT_DTOR(PTransportProviderParent);
}

auto PTransportProviderParent::ActorAlloc() -> void
{
}

auto PTransportProviderParent::ActorDealloc() -> void
{
    if (Manager()) {
        Manager()->DeallocManagee(PTransportProviderMsgStart, this);
    }
}

auto PTransportProviderParent::OtherPid() const -> ::base::ProcessId
{
    ::base::ProcessId pid =
        ::mozilla::ipc::IProtocol::ToplevelProtocol()->OtherPidMaybeInvalid();
    MOZ_RELEASE_ASSERT(pid != ::base::kInvalidProcessId);
    return pid;
}

auto PTransportProviderParent::Manager() const -> PNeckoParent*
{
    return static_cast<PNeckoParent*>(IProtocol::Manager());
}

auto PTransportProviderParent::AllManagedActorsCount() const -> uint32_t
{
    uint32_t total = 0;
    return total;

}

auto PTransportProviderParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PTransportProviderParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PTransportProviderParent::OnMessageReceived(const Message& msg__) -> PTransportProviderParent::Result
{
    switch (msg__.type()) {
    case MANAGED_ENDPOINT_BOUND_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            return MsgProcessed;
        }
    case MANAGED_ENDPOINT_DROPPED_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            this->ActorDisconnected(ManagedEndpointDropped);
            return MsgProcessed;
        }
    case PTransportProvider::Msg___delete____ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PTransportProvider", mozilla::ipc::ParentSide)) {
                mozilla::ipc::LogMessageForProtocol(
                    "PTransportProviderParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PTransportProvider::Msg___delete__", OTHER);

            mozilla::ipc::IPCResult __ok = (static_cast<TransportProviderParent*>(this))->Recv__delete__();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }


            this->ActorDisconnected(Deletion);

            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PTransportProviderParent::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PTransportProviderParent::Result
{
    return MsgNotKnown;
}

auto PTransportProviderParent::DoomSubtree() -> void
{
    SetDoomed();
}

auto PTransportProviderParent::PeekManagedActor() -> IProtocol*
{
    return nullptr;
}



} // namespace net
} // namespace mozilla
namespace IPC {
auto ParamTraits<::mozilla::net::PTransportProviderParent*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<::mozilla::net::PTransportProviderParent*>::Read(IPC::MessageReader* aReader) -> IPC::ReadResult<paramType>
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor = aReader->GetActor()
        ->ReadActor(aReader, true, "PTransportProvider", PTransportProviderMsgStart);
    if (actor.isSome()) {
        return static_cast<::mozilla::net::PTransportProviderParent*>(actor.ref());
    }
    return {};
}

} // namespace IPC
