//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PProfilerParent_h
#define PProfilerParent_h

#include "mozilla/PProfiler.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
class nsIFile;

namespace mozilla {
class TimeStamp;
} // namespace mozilla

namespace mozilla {
struct ProfileGenerationAdditionalInformation;
} // namespace mozilla

namespace mozilla {


class PProfilerParent :
    public mozilla::ipc::IToplevelProtocol
{
private:
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    typedef ::mozilla::GatherProfileProgress GatherProfileProgress;
    typedef ::mozilla::IPCProfileAndAdditionalInformation IPCProfileAndAdditionalInformation;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef base::ProcessId ProcessId;
    typedef ::mozilla::ProfileBufferChunkManagerUpdate ProfileBufferChunkManagerUpdate;
    typedef ::mozilla::ProfileBufferChunkMetadata ProfileBufferChunkMetadata;
    typedef ::mozilla::ProfileGenerationAdditionalInformation ProfileGenerationAdditionalInformation;
    typedef ::mozilla::ProfilerInitParams ProfilerInitParams;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::ipc::Shmem Shmem;
    typedef ::mozilla::TimeStamp TimeStamp;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

public:
    typedef MozPromise<bool, ResponseRejectReason, true> StartPromise;
    typedef MozPromise<bool, ResponseRejectReason, true> EnsureStartedPromise;
    typedef MozPromise<bool, ResponseRejectReason, true> StopPromise;
    typedef MozPromise<bool, ResponseRejectReason, true> PausePromise;
    typedef MozPromise<bool, ResponseRejectReason, true> ResumePromise;
    typedef MozPromise<bool, ResponseRejectReason, true> PauseSamplingPromise;
    typedef MozPromise<bool, ResponseRejectReason, true> ResumeSamplingPromise;
    typedef MozPromise<bool, ResponseRejectReason, true> WaitOnePeriodicSamplingPromise;
    typedef MozPromise<ProfileBufferChunkManagerUpdate, ResponseRejectReason, true> AwaitNextChunkManagerUpdatePromise;
    typedef MozPromise<IPCProfileAndAdditionalInformation, ResponseRejectReason, true> GatherProfilePromise;
    typedef MozPromise<GatherProfileProgress, ResponseRejectReason, true> GetGatherProfileProgressPromise;

protected:
    void
    ProcessingError(
            Result aCode,
            const char* aReason) override;
    bool
    ShouldContinueFromReplyTimeout() override;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PProfilerParent();

    virtual ~PProfilerParent();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    uint32_t
    AllManagedActorsCount() const override;

    void
    SendStart(
            const ProfilerInitParams& params,
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<StartPromise>
    SendStart(const ProfilerInitParams& params);

    void
    SendEnsureStarted(
            const ProfilerInitParams& params,
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<EnsureStartedPromise>
    SendEnsureStarted(const ProfilerInitParams& params);

    void
    SendStop(
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<StopPromise>
    SendStop();

    void
    SendPause(
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<PausePromise>
    SendPause();

    void
    SendResume(
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<ResumePromise>
    SendResume();

    void
    SendPauseSampling(
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<PauseSamplingPromise>
    SendPauseSampling();

    void
    SendResumeSampling(
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<ResumeSamplingPromise>
    SendResumeSampling();

    void
    SendWaitOnePeriodicSampling(
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<WaitOnePeriodicSamplingPromise>
    SendWaitOnePeriodicSampling();

    void
    SendAwaitNextChunkManagerUpdate(
            mozilla::ipc::ResolveCallback<ProfileBufferChunkManagerUpdate>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<AwaitNextChunkManagerUpdatePromise>
    SendAwaitNextChunkManagerUpdate();

    [[nodiscard]] bool
    SendDestroyReleasedChunksAtOrBefore(const TimeStamp& timeStamp);

    void
    SendGatherProfile(
            mozilla::ipc::ResolveCallback<IPCProfileAndAdditionalInformation>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<GatherProfilePromise>
    SendGatherProfile();

    void
    SendGetGatherProfileProgress(
            mozilla::ipc::ResolveCallback<GatherProfileProgress>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<GetGatherProfileProgressPromise>
    SendGetGatherProfileProgress();

    [[nodiscard]] bool
    SendClearAllPages();

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

    void
    DoomSubtree() override;

    IProtocol*
    PeekManagedActor() override;

private:
};


} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::PProfilerParent*>
{
    typedef ::mozilla::PProfilerParent* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PProfilerParent_h
