//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PSessionStoreChild_h
#define PSessionStoreChild_h

#include "mozilla/dom/PSessionStore.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "mozilla/dom/BrowsingContext.h"
#include "mozilla/dom/SessionStoreScrollData.h"

namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PInProcessChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PInProcessParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PInProcessChild;
} // namespace dom
} // namespace mozilla

struct CollectedInputDataValue;

struct nsPoint;

namespace mozilla {
namespace dom {


class PSessionStoreChild :
    public mozilla::ipc::IRefCountedProtocol
{
private:
    friend class ::mozilla::dom::PBrowserChild;
    friend class ::mozilla::dom::PInProcessChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    typedef ::mozilla::dom::sessionstore::Checkbox Checkbox;
    typedef ::CollectedInputDataValue CollectedInputDataValue;
    typedef ::mozilla::dom::sessionstore::DocShellRestoreState DocShellRestoreState;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    typedef ::mozilla::dom::sessionstore::FileList FileList;
    typedef ::mozilla::dom::sessionstore::FormData FormData;
    typedef ::mozilla::dom::sessionstore::FormEntry FormEntry;
    typedef ::mozilla::dom::sessionstore::FormEntryValue FormEntryValue;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::dom::MaybeDiscardedBrowsingContext MaybeDiscardedBrowsingContext;
    typedef ::mozilla::dom::MaybeSessionStoreZoom MaybeSessionStoreZoom;
    typedef ::mozilla::dom::sessionstore::MultipleSelect MultipleSelect;
    typedef ::mozilla::dom::PBrowserChild PBrowserChild;
    typedef ::mozilla::dom::PBrowserParent PBrowserParent;
    typedef ::mozilla::dom::PInProcessChild PInProcessChild;
    typedef ::mozilla::dom::PInProcessParent PInProcessParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::ipc::Shmem Shmem;
    typedef ::mozilla::dom::sessionstore::SingleSelect SingleSelect;
    typedef ::mozilla::dom::sessionstore::TextField TextField;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsPoint nsPoint;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

public:
    typedef std::function<void(const bool&)> FlushTabStateResolver;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PSessionStoreChild();

    virtual ~PSessionStoreChild();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    uint32_t
    AllManagedActorsCount() const override;

    bool
    SendSessionStoreUpdate(
            const mozilla::Maybe<nsCString>& aDocShellCaps,
            const mozilla::Maybe<bool>& aPrivateMode,
            const MaybeSessionStoreZoom& aZoom,
            const bool& aNeedCollectSHistory,
            const uint32_t& aEpoch);

    bool
    SendIncrementalSessionStoreUpdate(
            const MaybeDiscardedBrowsingContext& aBrowsingContext,
            const mozilla::Maybe<FormData>& aFormData,
            const mozilla::Maybe<nsPoint>& aScrollPosition,
            const uint32_t& aEpoch);

    bool
    SendResetSessionStore(
            const MaybeDiscardedBrowsingContext& aBrowsingContext,
            const uint32_t& aEpoch);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

    void
    DoomSubtree() override;

    IProtocol*
    PeekManagedActor() override;

private:
    bool mAwaitingManagedEndpointBind = false;

};


} // namespace dom
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::dom::PSessionStoreChild*>
{
    typedef ::mozilla::dom::PSessionStoreChild* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PSessionStoreChild_h
