//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebrtcGlobalParent_h
#define PWebrtcGlobalParent_h

#include "mozilla/dom/PWebrtcGlobal.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "mozilla/media/webrtc/WebrtcGlobal.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
struct RTCStatsReportInternal;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {


class PWebrtcGlobalParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class ::mozilla::dom::PContentParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::dom::PContentChild PContentChild;
    typedef ::mozilla::dom::PContentParent PContentParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef ::mozilla::dom::RTCStatsReportInternal RTCStatsReportInternal;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::ipc::Shmem Shmem;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::WebrtcGlobalLog WebrtcGlobalLog;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

public:
    typedef MozPromise<nsTArray<RTCStatsReportInternal>, ResponseRejectReason, true> GetStatsPromise;
    typedef MozPromise<WebrtcGlobalLog, ResponseRejectReason, true> GetLogPromise;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
    virtual mozilla::ipc::IPCResult
    RecvPeerConnectionCreated(
            const nsAString& aPcId,
            const bool& aIsLongTermStatsDisabled) = 0;
    virtual mozilla::ipc::IPCResult
    RecvPeerConnectionDestroyed(const nsAString& aPcId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvPeerConnectionFinalStats(const RTCStatsReportInternal& aFinalStats) = 0;
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PWebrtcGlobalParent();

    virtual ~PWebrtcGlobalParent();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    ::base::ProcessId
    OtherPid() const;

    PContentParent*
    Manager() const;

    uint32_t
    AllManagedActorsCount() const override;

    void
    SendGetStats(
            const nsAString& aPcIdFilter,
            mozilla::ipc::ResolveCallback<nsTArray<RTCStatsReportInternal>>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<GetStatsPromise>
    SendGetStats(const nsAString& aPcIdFilter);

    [[nodiscard]] bool
    SendClearStats();

    void
    SendGetLog(
            mozilla::ipc::ResolveCallback<WebrtcGlobalLog>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<GetLogPromise>
    SendGetLog();

    [[nodiscard]] bool
    SendClearLog();

    [[nodiscard]] bool
    SendSetAecLogging(const bool& aEnable);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

    void
    DoomSubtree() override;

    IProtocol*
    PeekManagedActor() override;

private:
    bool mAwaitingManagedEndpointBind = false;

};


} // namespace dom
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::dom::PWebrtcGlobalParent*>
{
    typedef ::mozilla::dom::PWebrtcGlobalParent* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PWebrtcGlobalParent_h
