//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PVRParent_h
#define PVRParent_h

#include "mozilla/gfx/PVR.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
class nsIFile;

// Headers for things that cannot be forward declared
#include "gfxTelemetry.h"
#include "moz_external_vr.h"
#include "mozilla/TimeStamp.h"
#include "mozilla/dom/NativeThreadId.h"
#include "mozilla/gfx/D3D11Checks.h"
#include "mozilla/gfx/Point.h"
#include "mozilla/gfx/Types.h"

namespace mozilla {
namespace gfx {
class PVRGPUParent;
} // namespace gfx
} // namespace mozilla
namespace mozilla {
namespace gfx {
class PVRGPUChild;
} // namespace gfx
} // namespace mozilla

struct DxgiAdapterDesc;

namespace mozilla {
struct null_t;
} // namespace mozilla

namespace mozilla {
struct void_t;
} // namespace mozilla

namespace mozilla {
struct null_t;
} // namespace mozilla

namespace mozilla {
namespace gfx {


class PVRParent :
    public mozilla::ipc::IToplevelProtocol
{
private:
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::gfx::BackendType BackendType;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    typedef ::mozilla::gfx::ContentDeviceData ContentDeviceData;
    typedef ::mozilla::gfx::D3D11DeviceStatus D3D11DeviceStatus;
    typedef ::mozilla::gfx::DevicePrefs DevicePrefs;
    typedef ::DxgiAdapterDesc DxgiAdapterDesc;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::gfx::FeatureFailure FeatureFailure;
    typedef ::mozilla::gfx::FeatureStatus FeatureStatus;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    typedef ::mozilla::gfx::GPUDeviceData GPUDeviceData;
    typedef ::mozilla::gfx::GfxInfoFeatureStatus GfxInfoFeatureStatus;
    typedef ::mozilla::gfx::GfxVarUpdate GfxVarUpdate;
    typedef ::mozilla::gfx::GfxVarValue GfxVarValue;
    typedef ::mozilla::gfx::IntSize IntSize;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::dom::MemoryReport MemoryReport;
    typedef ::mozilla::dom::NativeThreadId NativeThreadId;
    typedef ::mozilla::gfx::PVRGPUChild PVRGPUChild;
    typedef ::mozilla::gfx::PVRGPUParent PVRGPUParent;
    typedef ::mozilla::dom::Pref Pref;
    typedef ::mozilla::dom::PrefValue PrefValue;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::ipc::Shmem Shmem;
    typedef ::mozilla::TimeStamp TimeStamp;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::mozilla::gfx::VRControllerType VRControllerType;
    typedef ::mozilla::gfx::D3D11Checks::VideoFormatOption VideoFormatOption;
    typedef ::mozilla::gfx::D3D11Checks::VideoFormatOptionSet VideoFormatOptionSet;
    typedef ::gfxImageFormat gfxImageFormat;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::mozilla::null_t null_t;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;
    typedef ::mozilla::void_t void_t;

public:
    typedef std::function<void(const uint32_t&)> RequestMemoryReportResolver;

protected:
    void
    ProcessingError(
            Result aCode,
            const char* aReason) override;
    bool
    ShouldContinueFromReplyTimeout() override;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PVRParent();

    virtual ~PVRParent();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    ::base::ProcessId
    OtherPid() const;

    uint32_t
    AllManagedActorsCount() const override;

    [[nodiscard]] bool
    SendInitComplete();

    [[nodiscard]] bool
    SendOpenVRControllerActionPathToParent(const nsACString& aPath);

    [[nodiscard]] bool
    SendOpenVRControllerManifestPathToParent(
            const VRControllerType& aType,
            const nsACString& aPath);

    [[nodiscard]] bool
    SendInitCrashReporter(const NativeThreadId& threadId);

    [[nodiscard]] bool
    SendAddMemoryReport(const MemoryReport& aReport);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

    void
    DoomSubtree() override;

    IProtocol*
    PeekManagedActor() override;

private:
};


} // namespace gfx
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::gfx::PVRParent*>
{
    typedef ::mozilla::gfx::PVRParent* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PVRParent_h
