//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPVideoDecoderParent_h
#define PGMPVideoDecoderParent_h

#include "mozilla/gmp/PGMPVideoDecoder.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "GMPSanitizedExports.h"
#include "gmp-errors.h"
#include "gmp-video-codec.h"

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPVideoDecoderParent :
    public mozilla::ipc::IRefCountedProtocol
{
private:
    friend class ::mozilla::gmp::PGMPContentParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    typedef ::mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef ::mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef ::mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef ::mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef ::mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    typedef ::cdm::EncryptionScheme EncryptionScheme;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    typedef ::GMPBufferType GMPBufferType;
    typedef ::GMPErr GMPErr;
    typedef ::mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef ::GMPVideoCodec GMPVideoCodec;
    typedef ::mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef ::mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::gmp::NodeIdParts NodeIdParts;
    typedef ::mozilla::gmp::NodeIdVariant NodeIdVariant;
    typedef ::mozilla::gmp::PGMPContentChild PGMPContentChild;
    typedef ::mozilla::gmp::PGMPContentParent PGMPContentParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::ipc::Shmem Shmem;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
    virtual mozilla::ipc::IPCResult
    RecvDecoded(const GMPVideoi420FrameData& aDecodedFrame) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReceivedDecodedReferenceFrame(const uint64_t& aPictureId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReceivedDecodedFrame(const uint64_t& aPictureId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvInputDataExhausted() = 0;
    virtual mozilla::ipc::IPCResult
    RecvDrainComplete() = 0;
    virtual mozilla::ipc::IPCResult
    RecvResetComplete() = 0;
    virtual mozilla::ipc::IPCResult
    RecvError(const GMPErr& aErr) = 0;
    virtual mozilla::ipc::IPCResult
    RecvShutdown() = 0;
    virtual mozilla::ipc::IPCResult
    RecvParentShmemForPool(Shmem&& aEncodedBuffer) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNeedShmem(
            const uint32_t& aFrameBufferSize,
            Shmem* aMem) = 0;
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGMPVideoDecoderParent();

    virtual ~PGMPVideoDecoderParent();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    ::base::ProcessId
    OtherPid() const;

    PGMPContentParent*
    Manager() const;

    uint32_t
    AllManagedActorsCount() const override;

    [[nodiscard]] bool
    SendInitDecode(
            const GMPVideoCodec& aCodecSettings,
            mozilla::Span<uint8_t const> aCodecSpecific,
            const int32_t& aCoreCount);

    [[nodiscard]] bool
    SendDecode(
            const GMPVideoEncodedFrameData& aInputFrame,
            const bool& aMissingFrames,
            mozilla::Span<uint8_t const> aCodecSpecificInfo,
            const int64_t& aRenderTimeMs);

    [[nodiscard]] bool
    SendReset();

    [[nodiscard]] bool
    SendDrain();

    [[nodiscard]] bool
    SendDecodingComplete();

    [[nodiscard]] bool
    SendChildShmemForPool(Shmem&& aFrameBuffer);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

    void
    DoomSubtree() override;

    IProtocol*
    PeekManagedActor() override;

private:
    bool mAwaitingManagedEndpointBind = false;

};


} // namespace gmp
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::gmp::PGMPVideoDecoderParent*>
{
    typedef ::mozilla::gmp::PGMPVideoDecoderParent* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PGMPVideoDecoderParent_h
