//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PAPZParent_h
#define PAPZParent_h

#include "mozilla/layers/PAPZ.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "Units.h"
#include "mozilla/dom/ipc/IdType.h"
#include "mozilla/layers/AsyncDragMetrics.h"
#include "mozilla/layers/GeckoContentControllerTypes.h"
#include "mozilla/layers/LayersTypes.h"
#include "mozilla/layers/MatrixMessage.h"
#include "mozilla/layers/ScrollableLayerGuid.h"

namespace mozilla {
namespace layers {
class PCompositorBridgeParent;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PCompositorBridgeChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositorBridgeParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
struct RepaintRequest;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
struct ScrollableLayerGuid;
} // namespace layers
} // namespace mozilla

class nsRegion;

namespace mozilla {
namespace layers {


class PAPZParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class ::mozilla::layers::PCompositorBridgeParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::layers::AsyncDragMetrics AsyncDragMetrics;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    typedef ::mozilla::CSSRect CSSRect;
    typedef ::mozilla::dom::ContentParentId ContentParentId;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    typedef ::mozilla::layers::GeckoContentController_APZStateChange GeckoContentController_APZStateChange;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::layers::MatrixMessage MatrixMessage;
    typedef ::mozilla::layers::PCompositorBridgeChild PCompositorBridgeChild;
    typedef ::mozilla::layers::PCompositorBridgeParent PCompositorBridgeParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef ::mozilla::layers::RepaintRequest RepaintRequest;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::layers::ScrollDirection ScrollDirection;
    typedef ::mozilla::layers::ScrollableLayerGuid ScrollableLayerGuid;
    typedef ::mozilla::ipc::Shmem Shmem;
    typedef ::mozilla::dom::TabId TabId;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::mozilla::layers::ScrollableLayerGuid::ViewID ViewID;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsRegion nsRegion;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PAPZParent();

    virtual ~PAPZParent();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    ::base::ProcessId
    OtherPid() const;

    PCompositorBridgeParent*
    Manager() const;

    uint32_t
    AllManagedActorsCount() const override;

    [[nodiscard]] bool
    SendLayerTransforms(mozilla::Span<MatrixMessage const> aTransforms);

    [[nodiscard]] bool
    SendRequestContentRepaint(const RepaintRequest& request);

    [[nodiscard]] bool
    SendUpdateOverscrollVelocity(
            const ScrollableLayerGuid& aGuid,
            const float& aX,
            const float& aY,
            const bool& aIsRootContent);

    [[nodiscard]] bool
    SendUpdateOverscrollOffset(
            const ScrollableLayerGuid& aGuid,
            const float& aX,
            const float& aY,
            const bool& aIsRootContent);

    [[nodiscard]] bool
    SendNotifyMozMouseScrollEvent(
            const ViewID& aScrollId,
            const nsAString& aEvent);

    [[nodiscard]] bool
    SendNotifyAPZStateChange(
            const ScrollableLayerGuid& aGuid,
            const GeckoContentController_APZStateChange& aChange,
            const int& aArg,
            const mozilla::Maybe<uint64_t>& aInputBlockId);

    [[nodiscard]] bool
    SendNotifyFlushComplete();

    [[nodiscard]] bool
    SendNotifyAsyncScrollbarDragInitiated(
            const uint64_t& aDragBlockId,
            const ViewID& aScrollId,
            const ScrollDirection& aDirection);

    [[nodiscard]] bool
    SendNotifyAsyncScrollbarDragRejected(const ViewID& aScrollId);

    [[nodiscard]] bool
    SendNotifyAsyncAutoscrollRejected(const ViewID& aScrollId);

    [[nodiscard]] bool
    SendDestroy();

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

    void
    DoomSubtree() override;

    IProtocol*
    PeekManagedActor() override;

private:
    bool mAwaitingManagedEndpointBind = false;

};


} // namespace layers
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::layers::PAPZParent*>
{
    typedef ::mozilla::layers::PAPZParent* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PAPZParent_h
