//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PDNSRequestChild_h
#define PDNSRequestChild_h

#include "mozilla/net/PDNSRequest.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "mozilla/ipc/BackgroundUtils.h"
#include "mozilla/net/DNS.h"
#include "mozilla/net/DNSByTypeRecord.h"
#include "nsIDNSService.h"
#include "nsIRequest.h"

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PSocketProcessChild;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PSocketProcessParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PSocketProcessChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class PDNSRequestChild :
    public mozilla::ipc::IRefCountedProtocol
{
private:
    friend class ::mozilla::net::PNeckoChild;
    friend class ::mozilla::net::PSocketProcessChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    typedef ::nsIDNSService::DNSFlags DNSFlags;
    typedef ::mozilla::net::DNSRecord DNSRecord;
    typedef ::mozilla::net::DNSRequestResponse DNSRequestResponse;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    typedef ::mozilla::net::IPCTypeRecord IPCTypeRecord;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::net::NetAddr NetAddr;
    typedef ::mozilla::OriginAttributes OriginAttributes;
    typedef ::mozilla::net::PNeckoChild PNeckoChild;
    typedef ::mozilla::net::PNeckoParent PNeckoParent;
    typedef ::mozilla::net::PSocketProcessChild PSocketProcessChild;
    typedef ::mozilla::net::PSocketProcessParent PSocketProcessParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::ipc::Shmem Shmem;
    typedef ::nsIRequest::TRRMode TRRMode;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PDNSRequestChild();

    virtual ~PDNSRequestChild();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    ::base::ProcessId
    OtherPid() const;

    uint32_t
    AllManagedActorsCount() const override;

    bool
    SendCancelDNSRequest(
            const nsACString& hostName,
            const nsACString& trrServer,
            const int32_t& port,
            const uint16_t& type,
            const OriginAttributes& originAttributes,
            const DNSFlags& flags,
            const nsresult& reason);

    static bool
    Send__delete__(PDNSRequestChild* actor);

    bool
    SendLookupCompleted(const DNSRequestResponse& reply);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

    void
    DoomSubtree() override;

    IProtocol*
    PeekManagedActor() override;

private:
    bool mAwaitingManagedEndpointBind = false;

};


} // namespace net
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::net::PDNSRequestChild*>
{
    typedef ::mozilla::net::PDNSRequestChild* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PDNSRequestChild_h
